# 从 Babylon 3.3 移植到 4.0.0 的 修改

## 移植后，未验证的功能

* 光照图

### 已撤销 3.3 时的额外处理

* 动画切换时的优化

## 功能拓展

* Engines/Engine.ts
    + PI_ALPHA_PREMULTIPLIED 添加自定义混合模式

### 功能重载 添加 extend.ts 模块,对需要修改的 BABYLON 底层代码进行覆写

* BABYLON.InternalTexture.prototype.dispose
    + 通过ResTab 控制 纹理 延时释放
* BABYLON.Animation.prototype.setKeys
    + 关键帧为纯数据，并不涉及状态的变化， 不需要总是拷贝关键帧

### 额外注意点

* 模型销毁时,处理 AnimationGroup 步骤：
    + 先 stop 再 dispose , (stop 销毁帧数据, dispose 正常销毁逻辑数据)
* disposeMaterialAndTextures = false 全局替换
    + disposeMaterialAndTextures = true
    + 默认销毁模型时销毁材质

## pi_babylon的封装

* Scene
    + render 方法可由项目逻辑独立调用
    + 可设置 Before/After renderCall
* SceneManager
    + 创建/销毁场景
    + 可指定 mianScene，仅自动渲染 mainScene
    + 可设置 Before/After renderCall - 与 mainScene Before/After renderCall 无关,即使mainScene不存在也会在自身循环内调用
    + 非 mainScene 渲染,
        - 可调用 renderOtherScene
        - 可调用 scene.render
* 目标场景需要响应事件则添加，不响应则不管
    ```
        getRoot().addDownListener(<any>mainScene.onPointerDown);
        getRoot().addMoveListener(<any>mainScene.onPointerMove);
        getRoot().addUpListener(<any>mainScene.onPointerUp);
        getRoot().addClickListener(<any>mainScene.onPointerClick);
    ```
+ 添加场景事件监听
    - mainScene.addClickListen
+ 主场景渲染，由项目代码控制渲染时机 
    - getGlobal().setPermanentBefore(SceneManager.renderLoop)


### 环境判断相关

* Misc/Tools.ts
    + LoadImage 方法
        - 微信小游戏 - 20190213-000000 - 优先判断是否为字符串,先判断Blob再判断字符串,如果环境不存在Blob将导致错误，也就不能到达字符串判断
* Engines/Engine.ts
    + _initGLContext 方法, this._gl.getExtension('WEBGL_draw_buffers') 标识获取
        - 微信端问题: 7.0.7 返回 undefined,微信官方新版本已修复

### 初始状态调整

* AbstractMesh
    + public isPickable = false; // 默认模型都不可点击命中
* glTFFileLoader.ts
    + public animationStartMode = GLTFLoaderAnimationStartMode.NONE; // 模型加载后默认不播动画