import { ModelObj } from "./model_obj";
import * as BABYLON from "./render3d/context";

export type TBoneAttachInfo = [string, string, string, string, [number, number, number], [number, number, number], [number, number, number]];
export const KeyAttachName = 0;
export const KeyModelName = 1;
export const KeyFlagName = 2;
export const KeyBoneName = 3;
export const KeyPosition = 4;
export const KeyRotation = 5;
export const KeyScaling = 6;

export function attachModelToSkeletonModel(attachModel: ModelObj, targetModel: ModelObj, cfg: TBoneAttachInfo) {
    let skeleton: BABYLON.Skeleton;
    targetModel.skeletonMap.forEach((skl) => {
        skeleton = skl;
    });

    if (skeleton) {
        attachModel.setPosition(...cfg[KeyPosition]);
        attachModel.setRotate(...cfg[KeyRotation]);
        attachModel.setScale(...cfg[KeyScaling]);
        // skeleton.piBoneAttachment(attachModel.rootImpl, cfg[KeyBoneName]);
    }
}