export interface _EFillMode {
    None        : 0 | _EFillMode,
    Forwards    : 1 | _EFillMode,
    Backwards   : 2 | _EFillMode,
    Both        : 3 | _EFillMode,
}
/**
*/
export interface _BlendMode {
    Normal      : 0 | _BlendMode,
    AlphaAdd    : 1 | _BlendMode,
    Subtract    : 2 | _BlendMode,
    Multiply    : 3 | _BlendMode,
    OneOne      : 4 | _BlendMode,
}
/**
*/
export interface _Direction {
    Left    : 0 | _Direction,
    Right   : 1 | _Direction,
    Up      : 2 | _Direction,
    Down    : 3 | _Direction,
}
/**
*/
export interface _KeySpineShader {
    Colored             : 0 | _KeySpineShader,
    ColoredTextured     : 1 | _KeySpineShader,
    TwoColoredTextured  : 2 | _KeySpineShader,
}
/**
*/
export interface _EAnimeCurve {
    FrameValues         : 0 | _EAnimeCurve,
    FrameValuesStep     : 1 | _EAnimeCurve,
    EasingCurve         : 2 | _EAnimeCurve,
    MinMaxCurve         : 3 | _EAnimeCurve,
    CubicBezierCurve    : 4 | _EAnimeCurve,
    GLTFCubicSpline     : 5 | _EAnimeCurve,
}
/**
*/
export interface _TraceOption {
    None    : 0 | _TraceOption,
    Record  : 1 | _TraceOption,
    Play    : 2 | _TraceOption,
}
/**
*/
export interface _EAnimePropertyID {
    LocalPosition       :   0 | _EAnimePropertyID,
    LocalRotation       :   1 | _EAnimePropertyID,
    LocalScaling        :   2 | _EAnimePropertyID,
    MainTexUScale       :   3 | _EAnimePropertyID,
    MainTexVScale       :   4 | _EAnimePropertyID,
    MainTexUOffset      :   5 | _EAnimePropertyID,
    MainTexVOffset      :   6 | _EAnimePropertyID,
    Alpha               :   7 | _EAnimePropertyID,
    MainColor           :   8 | _EAnimePropertyID,
    CameraOrthSize      :   9 | _EAnimePropertyID,
    CameraFov           :  10 | _EAnimePropertyID,
    Enable              :  11 | _EAnimePropertyID,
    LocalEulerAngles    :  12 | _EAnimePropertyID,
    Intensity           :  13 | _EAnimePropertyID,
    LightDiffuse        :  14 | _EAnimePropertyID,
    AlphaCutoff         :  15 | _EAnimePropertyID,
    CellId              :  16 | _EAnimePropertyID,
    OpacityTexUScale    :  17 | _EAnimePropertyID,
    OpacityTexVScale    :  18 | _EAnimePropertyID,
    OpacityTexUOffset   :  19 | _EAnimePropertyID,
    OpacityTexVOffset   :  20 | _EAnimePropertyID,
    MaskCutoff          :  21 | _EAnimePropertyID,
    MaskTexUScale       :  22 | _EAnimePropertyID,
    MaskTexVScale       :  23 | _EAnimePropertyID,
    MaskTexUOffset      :  24 | _EAnimePropertyID,
    MaskTexVOffset      :  25 | _EAnimePropertyID,
    MainTexTilloff      :  50 | _EAnimePropertyID,
    MaskTexTilloff      :  51 | _EAnimePropertyID,
    OpacityTexTilloff   :  52 | _EAnimePropertyID,
    BoneOffset          : 100 | _EAnimePropertyID,
    IndicesRange        : 101 | _EAnimePropertyID,
}
/**
*/
export interface _TileFlagType {
    All     : 0 | _TileFlagType,
    Center  : 1 | _TileFlagType,
    Right   : 2 | _TileFlagType,
    Down    : 4 | _TileFlagType,
}
/**
* blocks.regist::<(.*)>\(\);
*/
export interface _BuiltinNodeMaterialBlock {
    BlockFloat                          :  0 | _BuiltinNodeMaterialBlock,
    BlockViewDirection                  :  1 | _BuiltinNodeMaterialBlock,
    BlockColorSpace                     :  2 | _BuiltinNodeMaterialBlock,
    BlockColorGray                      :  3 | _BuiltinNodeMaterialBlock,
    BlockColorHSV                       :  4 | _BuiltinNodeMaterialBlock,
    BlockTextureChannel                 :  5 | _BuiltinNodeMaterialBlock,
    BlockUVOffsetSpeed                  :  6 | _BuiltinNodeMaterialBlock,
    BlockFog                            :  7 | _BuiltinNodeMaterialBlock,
    BlockCutoff                         :  8 | _BuiltinNodeMaterialBlock,
    BlockMainTexture                    :  9 | _BuiltinNodeMaterialBlock,
    BlockMainTextureUVOffsetSpeed       : 10 | _BuiltinNodeMaterialBlock,
    BlockOpacity                        : 11 | _BuiltinNodeMaterialBlock,
    BlockOpacityTexture                 : 12 | _BuiltinNodeMaterialBlock,
    BlockOpacityTextureUVOffsetSpeed    : 13 | _BuiltinNodeMaterialBlock,
    BlockOpacity2Texture                : 14 | _BuiltinNodeMaterialBlock,
    BlockOpacity2TextureUVOffsetSpeed   : 15 | _BuiltinNodeMaterialBlock,
    BlockEmissiveTexture                : 16 | _BuiltinNodeMaterialBlock,
    BlockEmissiveTextureUVOffsetSpeed   : 17 | _BuiltinNodeMaterialBlock,
    BlockMixTexture                     : 18 | _BuiltinNodeMaterialBlock,
    BlockMixTextureUVOffsetSpeed        : 19 | _BuiltinNodeMaterialBlock,
    BlockMaskTexture                    : 20 | _BuiltinNodeMaterialBlock,
    BlockMaskTextureUVOffsetSpeed       : 21 | _BuiltinNodeMaterialBlock,
    BlockFresnel                        : 22 | _BuiltinNodeMaterialBlock,
    BlockEmissiveFresnel                : 23 | _BuiltinNodeMaterialBlock,
    BlockOpacityFresnel                 : 24 | _BuiltinNodeMaterialBlock,
    BlockPremultiplyResult              : 25 | _BuiltinNodeMaterialBlock,
}
/**
*/
export interface _ELoopMode {
/**
* 不循环
*/
Not : 0 | _ELoopMode,
/**
* 正向循环
* * 指定循环次数 - None 无限循环
*/
Positive : 1 | _ELoopMode,
/**
* 反向循环
* * 指定循环次数 - None 无限循环
*/
Opposite : 2 | _ELoopMode,
/**
* 正向反复循环
* * 指定循环次数 - None 无限循环
*/
PositivePly : 3 | _ELoopMode,
/**
* 反向反复循环
* * 指定循环次数 - None 无限循环
*/
OppositePly : 4 | _ELoopMode,
}
/**
*/
export interface _EAmountMode {
    None            :  0 | _EAmountMode,
    BackIn          :  1 | _EAmountMode,
    BackOut         :  2 | _EAmountMode,
    BackInOut       :  3 | _EAmountMode,
    CircleIn        :  4 | _EAmountMode,
    CircleOut       :  5 | _EAmountMode,
    CircleInOut     :  6 | _EAmountMode,
    CubicIn         :  7 | _EAmountMode,
    CubicOut        :  8 | _EAmountMode,
    CubicInOut      :  9 | _EAmountMode,
    SineIn          : 10 | _EAmountMode,
    SineOut         : 11 | _EAmountMode,
    SineInOut       : 12 | _EAmountMode,
    QuadIn          : 13 | _EAmountMode,
    QuadOut         : 14 | _EAmountMode,
    QuadInOut       : 15 | _EAmountMode,
    QuartIn         : 16 | _EAmountMode,
    QuartOut        : 17 | _EAmountMode,
    QuartInOut      : 18 | _EAmountMode,
    QuintIn         : 19 | _EAmountMode,
    QuintOut        : 20 | _EAmountMode,
    QuintInOut      : 21 | _EAmountMode,
    ExpoIn          : 22 | _EAmountMode,
    ExpoOut         : 23 | _EAmountMode,
    ExpoInOut       : 24 | _EAmountMode,
    ElasticIn       : 25 | _EAmountMode,
    ElasticOut      : 26 | _EAmountMode,
    ElasticInOut    : 27 | _EAmountMode,
    BounceIn        : 28 | _EAmountMode,
    BounceOut       : 29 | _EAmountMode,
    BounceInOut     : 30 | _EAmountMode,
    JumpStart       : 31 | _EAmountMode,
    JumpEnd         : 32 | _EAmountMode,
    JumpNone        : 33 | _EAmountMode,
    JumpBoth        : 34 | _EAmountMode,
    CubicBezier     : 35 | _EAmountMode,
}
/**
* Initializes the global logger setting `max_log_level` to the given value.
*/
export interface _Level {
/**
* The "error" level.
*
* Designates very serious errors.
*/
Error : 1 | _Level,
/**
* The "warn" level.
*
* Designates hazardous situations.
*/
Warn : 2 | _Level,
/**
* The "info" level.
*
* Designates useful information.
*/
Info : 3 | _Level,
/**
* The "debug" level.
*
* Designates lower priority information.
*/
Debug : 4 | _Level,
/**
* The "trace" level.
*
* Designates very low priority, often extremely verbose, information.
*/
Trace : 5 | _Level,
}
/**
*/
export interface _EAnimationGroupListen {
    Start   : 0 | _EAnimationGroupListen,
    End     : 1 | _EAnimationGroupListen,
    Loop    : 2 | _EAnimationGroupListen,
    Frame   : 3 | _EAnimationGroupListen,
}

export interface IActionSetScene3D {
    free?(): void;
}

export interface _ActionSetScene3D {
    /**
    * @param {Engine} app
    * @returns {ActionSetScene3D}
    */
    create(app: INativeEngine): IActionSetScene3D;
}
export interface IAtom {
    free?(): void;
    get_hash(): number;
}
export interface _Atom {
    /**
    * @param {string} value
    * @returns {Atom}
    */
    from_string(value: string): IAtom;
    /**
    * @param {number} value
    * @returns {string | undefined}
    */
    get_string_by_hash(value: number): string | undefined;
}

export interface ICommandsExchangeD3 {
    free?(): void;
}
    /**
    */
export interface _CommandsExchangeD3 {
    /**
    * @returns {CommandsExchangeD3}
    */
    create(): ICommandsExchangeD3;
}
/**
*/
export interface ICommandsExchangeSpine {
    free?(): void;
}
/**
 */
export interface _CommandsExchangeSpine {
    /**
     * @returns {CommandsExchangeSpine}
     */
    create(): ICommandsExchangeSpine;
}
/**
 */
export interface IDataTextureRes {
    free?(): void;
}
/**
*/
export interface INativeEngine {
    free?(): void;
}
/**
*/
export interface IGLTFRes {
    free?(): void;
}
export interface IGeometryMeta {
    free?(): void;
}
/**
*/
export interface _GeometryMeta {
    /**
    * @returns {GeometryMeta}
    */
    create_empty(): IGeometryMeta;
    /**
    * @returns {GeometryMeta}
    */
    create_box(): IGeometryMeta;
    /**
    * @returns {GeometryMeta}
    */
    create_quad(): IGeometryMeta;
}
/**
*/
export interface IVBMeta {
    free?(): void;
}
/**
*/
export interface _VBMeta {
    /**
    * @param {string} name
    * @param {number | undefined} [start]
    * @param {number | undefined} [end]
    * @returns {VBMeta}
    */
    create(name: string, start?: number, end?: number): IVBMeta;
}
/**
*/
export interface IVInstanceAttributes {
    free?(): void;
}
/**
*/
export interface _VInstanceAttributes {
    /**
    * @param {boolean} instane_matrix
    * @returns {VInstanceAttributes}
    */
    create(instane_matrix: boolean): IVInstanceAttributes;
}
/**
*/
export interface IVertexBufferRes {
    free?(): void;
}
/**
*/
export interface ImageRes {
    free?(): void;
}
export interface IMaterialUniformDefines {
    free?(): void;
}
/**
*/
export interface _MaterialUniformDefines {
    /**
    * @returns {MaterialUniformDefines}
    */
    create(): IMaterialUniformDefines;
}
/**
*/
export interface INodeMaterialBlock {
    free?(): void;
}
/**
*/
export interface _NodeMaterialBlock {
    /**
     * @param {Atom} key
     * @param {string} vs_define
     * @param {string} vs_surface
     * @param {string} fs_define
     * @param {string} fs_surface
     * @param {number | undefined} [bind_defines]
     * @returns {NodeMaterialBlock}
     */
    create(key: IAtom, vs_define: string, vs_surface: string, fs_define: string, fs_surface: string, bind_defines?: number): INodeMaterialBlock;
}
/**
*/
export interface INodematerialIncludes {
    free?(): void;
}
export interface _NodematerialIncludes {
    /**
    * @returns {NodematerialIncludes}
    */
    create(): INodematerialIncludes;
}
/**
*/
export interface IP3DShaderMeta {
    free?(): void;
}
/**
*/
export interface IP3DShaderVaryings {
    free?(): void;
}
export interface _P3DShaderVaryings {
    /**
    * @returns {P3DShaderVaryings}
    */
    create(): IP3DShaderVaryings;
}
/**
*/
export interface IPTextureFrameAtlas {
    free?(): void;
}

export interface IResAllocator {
    free?(): void;
    /**
    * 整理方法， 将无人使用的资源放入到LruCache， 清理过时的资源
    * 就是LruMgr有总内存上限， 按权重分给其下的LRU。 如果有LRU有空闲， 则会减少其max_size, 按权重提高那些满的LRU的max_size
    */
    collect(): void;
    /**
    * 创建一个资源， 如果资源已经存在，则会修改资源的配置
    * @param {number} ty
    * @param {number} min_capacity
    * @param {number} weight
    * @param {number} time_out
    * @returns {ResMgr}
    */
    register_to_resmgr(ty: number, min_capacity: number, weight: number, time_out: number): IResMgr;
    /**
    * @returns {number}
    */
    size(): number;
    /**
    * @returns {string}
    */
    account_details(): string;
}
/**
* 资源管理器
*/
export interface _ResAllocator {
    /**
    * 创建资源管理器的实例
    * @param {number} total_capacity
    * @returns {ResAllocator}
    */
    new(total_capacity: number): IResAllocator;
}

/**
 */
export interface ResHandle {
    free?(): void;
}
/**
* 资源管理器
*/
export interface IResMgr {
    free?(): void;
    /**
    * 创建一个资源， 如果资源已经存在，旧的资源将被覆盖
    * 如果创建的资源类型未注册，将崩溃
    * @param {number} key
    * @param {number} cost
    * @returns {ResRef}
    */
    create_res(key: number, cost: number): IResRef;
    /**
    * 获取资源
    * @param {number} key
    * @returns {ResRef | undefined}
    */
    get_res(key: number): IResRef | undefined;
}
/**
* 资源包装
*/
export interface IResRef {
    free?(): void;
}
/**
*/
export interface IResTextureFrameAtlas {
    free?(): void;
}
/**
*/
export interface ISpineTextureLoadRecord {
    free?(): void;
    /**
    * @param {Atom} key
    * @returns {TextureDefaultView | undefined}
    */
    success(key: IAtom): ITextureDefaultView | undefined;
    /**
    * @param {Atom} key
    * @returns {string | undefined}
    */
    fail(key: IAtom): string | undefined;
    /**
    */
    clear(): void;
}
/**
*/
export interface _SpineTextureLoadRecord {
    /**
    * @returns {SpineTextureLoadRecord}
    */
    new(): ISpineTextureLoadRecord;
}
/**
*/
export interface ITextureDefaultView {
    free?(): void;
}
export interface IEngineAPI {
    /* tslint:disable */
    /* eslint-disable */
    /**
    * @param {Level} _level
    */
    init_logger(_level: _Level): void;
    /**
    * @param {Function} f
    */
    set_destroy_callback(f: Function): void;
    /**
    * 设置日志过滤器
    * 如果过滤器格式错误， 日志过滤器未初始化， 则设置将失败， 但不会panic
    * @param {Engine} engine
    * @param {string} filter
    */
    set_log_filter(engine: INativeEngine, filter: string): void;
    /**
    * @param {Engine} app
    * @param {boolean} value
    */
    set_is_not_run(app: INativeEngine, value: boolean): void;
    /**
    * @param {Engine} app
    * @param {boolean} spine
    * @param {Uint32Array} param
    */
    init_engine_3d(app: INativeEngine, spine: boolean, param: Uint32Array): void;
    /**
    * @param {Engine} app
    * @param {Uint32Array} data
    */
    p3d_device_limis(app: INativeEngine, data: Uint32Array): void;
    /**
    * @param {Engine} app
    */
    p3d_init_engine(app: INativeEngine): void;
    /**
    * @param {Engine} app
    * @returns {number}
    */
    p3d_entity(app: INativeEngine): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} entity
    */
    p3d_dispose(cmds: ICommandsExchangeD3, entity: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    */
    p3d_scene_dispose(cmds: ICommandsExchangeD3, scene: number): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} scene_max_direct_light_count
    * @param {number} scene_max_point_light_count
    * @param {number} scene_max_spot_light_count
    * @param {number} scene_max_hemi_light_count
    * @param {number} scene_max_shadow_count
    * @param {number} model_max_direct_light_count
    * @param {number} model_max_point_light_count
    * @param {number} model_max_spot_light_count
    * @param {number} model_max_hemi_light_count
    */
    p3d_lighting_shadow_limit(app: INativeEngine, param: IActionSetScene3D, scene_max_direct_light_count: number, scene_max_point_light_count: number, scene_max_spot_light_count: number, scene_max_hemi_light_count: number, scene_max_shadow_count: number, model_max_direct_light_count: number, model_max_point_light_count: number, model_max_spot_light_count: number, model_max_hemi_light_count: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} before
    * @param {number} after
    * @param {boolean} isdisconnect
    */
    p3d_render_graphic(cmds: ICommandsExchangeD3, before: number, after: number, isdisconnect: boolean): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} entity
    * @param {Float32Array} matrix
    * @returns {boolean}
    */
    p3d_query_world_matrix(app: INativeEngine, param: IActionSetScene3D, entity: number, matrix: Float32Array): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} entity
    * @param {Float32Array} result
    * @returns {boolean}
    */
    p3d_query_scene_state(app: INativeEngine, param: IActionSetScene3D, entity: number, result: Float32Array): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {boolean} active
    */
    p3d_engine_state(app: INativeEngine, param: IActionSetScene3D, active: boolean): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {boolean} debug
    */
    p3d_engine_debug(app: INativeEngine, param: IActionSetScene3D, debug: boolean): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {Float32Array} result
    */
    p3d_query_performance_state(app: INativeEngine, param: IActionSetScene3D, result: Float32Array): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {CommandsExchangeD3} commands
    * @param {Float32Array} result
    */
    p3d_query_resource_state(app: INativeEngine, param: IActionSetScene3D, commands: ICommandsExchangeD3, result: Float32Array): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {Float64Array} result
    * @returns {number}
    */
    p3d_query_resource_memory(app: INativeEngine, param: IActionSetScene3D, result: Float64Array): number;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {Float32Array} result
    */
    p3d_material_state(app: INativeEngine, param: IActionSetScene3D, result: Float32Array): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number | undefined} scene
    * @param {Float32Array} result
    */
    p3d_mesh_state(app: INativeEngine, param: IActionSetScene3D, scene: number | undefined, result: Float32Array): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number | undefined} scene
    * @param {Float32Array} result
    */
    p3d_transform_state(app: INativeEngine, param: IActionSetScene3D, scene: number | undefined, result: Float32Array): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number | undefined} transform
    * @param {Float32Array} result
    * @returns {boolean}
    */
    p3d_query_transform_state(app: INativeEngine, param: IActionSetScene3D, transform: number | undefined, result: Float32Array): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number | undefined} camera
    * @param {Float32Array} result
    */
    p3d_camera_state(app: INativeEngine, param: IActionSetScene3D, camera: number | undefined, result: Float32Array): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {Float32Array} result
    */
    p3d_texture_loader_state(app: INativeEngine, param: IActionSetScene3D, result: Float32Array): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {Uint32Array} info
    * @param {boolean} flag
    * @returns {number}
    */
    p3d_errors(app: INativeEngine, param: IActionSetScene3D, info: Uint32Array, flag: boolean): number;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {boolean} val
    */
    p3d_global_state(app: INativeEngine, param: IActionSetScene3D, val: boolean): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} entity
    * @param {Float32Array} matrix
    * @returns {boolean}
    */
    p3d_query_local_matrix(app: INativeEngine, param: IActionSetScene3D, entity: number, matrix: Float32Array): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} entity
    * @param {Float32Array} matrix
    * @returns {boolean}
    */
    p3d_query_view_matrix(app: INativeEngine, param: IActionSetScene3D, entity: number, matrix: Float32Array): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} entity
    * @param {Float32Array} matrix
    * @returns {boolean}
    */
    p3d_query_project_matrix(app: INativeEngine, param: IActionSetScene3D, entity: number, matrix: Float32Array): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} entity
    * @param {Float32Array} matrix
    * @returns {boolean}
    */
    p3d_query_viewproject_matrix(app: INativeEngine, param: IActionSetScene3D, entity: number, matrix: Float32Array): boolean;
    /**
    * @param {GLTFRes} item
    * @returns {string}
    */
    p3d_gltf_val(item: IGLTFRes): string;
    /**
    * 创建动画组
    * @param {GLTFRes} gltf
    * @param {number} group_index
    * @param {number} channel_index
    * @returns {number}
    */
    p3d_animation_curve_id_bygltf(gltf: IGLTFRes, group_index: number, channel_index: number): number;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} entity
    * @param {Atom} baseurl
    * @param {string} dyndesc
    */
    p3d_create_gltf_load(app: INativeEngine, param: IActionSetScene3D, entity: number, baseurl: IAtom, dyndesc: string): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {Float64Array} success
    * @param {Float64Array} failed
    */
    p3d_query_gltf_load(app: INativeEngine, param: IActionSetScene3D, success: Float64Array, failed: Float64Array): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} entity
    * @returns {GLTFRes | undefined}
    */
    p3d_get_gltf(app: INativeEngine, param: IActionSetScene3D, entity: number): IGLTFRes | undefined;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} entity
    * @returns {string | undefined}
    */
    p3d_get_gltf_fail_reason(app: INativeEngine, param: IActionSetScene3D, entity: number): string | undefined;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {Atom} url
    * @param {boolean} srgb
    * @param {boolean} compressed
    * @param {number} depth_or_array_layers
    * @returns {number}
    */
    p3d_create_image_load(app: INativeEngine, param: IActionSetScene3D, url: IAtom, srgb: boolean, compressed: boolean, depth_or_array_layers: number): number;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {Float64Array} success
    * @param {Float64Array} failed
    */
    p3d_query_image_load(app: INativeEngine, param: IActionSetScene3D, success: Float64Array, failed: Float64Array): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} id
    * @returns {ImageRes | undefined}
    */
    p3d_get_image(app: INativeEngine, param: IActionSetScene3D, id: number): ImageRes | undefined;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} id
    * @returns {string | undefined}
    */
    p3d_get_image_fail_reason(app: INativeEngine, param: IActionSetScene3D, id: number): string | undefined;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} id
    * @param {Float64Array} info
    * @returns {number}
    */
    p3d_query_children(app: INativeEngine, param: IActionSetScene3D, id: number, info: Float64Array): number;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} id
    * @param {Uint32Array} info
    * @returns {boolean}
    */
    p3d_query_mesh_info(app: INativeEngine, param: IActionSetScene3D, id: number, info: Uint32Array): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} id
    * @param {Uint32Array} info
    * @returns {boolean}
    */
    p3d_query_material_info(app: INativeEngine, param: IActionSetScene3D, id: number, info: Uint32Array): boolean;
    /**
    * 正向渲染
    * Pass 配置使用默认值
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} cullingmode
    * @param {number} collidermode
    * @param {Int32Array} vals
    * @returns {number}
    */
    p3d_scene(app: INativeEngine, cmds: ICommandsExchangeD3, cullingmode: number, collidermode: number, vals: Int32Array): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {boolean} val
    */
    p3d_scene_animation_enable(cmds: ICommandsExchangeD3, scene: number, val: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} val
    */
    p3d_scene_time(cmds: ICommandsExchangeD3, scene: number, val: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} r
    * @param {number} g
    * @param {number} b
    */
    p3d_scene_fogcolor(cmds: ICommandsExchangeD3, scene: number, r: number, g: number, b: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} mode
    * @param {number} param0
    * @param {number} param1
    * @param {number} param2
    */
    p3d_scene_fogparam(cmds: ICommandsExchangeD3, scene: number, mode: number, param0: number, param1: number, param2: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} r
    * @param {number} g
    * @param {number} b
    */
    p3d_scene_ambientcolor(cmds: ICommandsExchangeD3, scene: number, r: number, g: number, b: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} val
    */
    p3d_scene_ambientintensity(cmds: ICommandsExchangeD3, scene: number, val: number): void;
    /**
    *
    * 相机渲染像素宽高
    * @param {CommandsExchangeD3} cmds
    * @param {number} node
    * @param {number} val
    */
    p3d_layermask(cmds: ICommandsExchangeD3, node: number, val: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {Atom} url
    * @param {boolean} compressed
    */
    p3d_scene_brdf_texture(cmds: ICommandsExchangeD3, scene: number, url: IAtom, compressed: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {Atom} url
    * @param {boolean} data_is_image
    */
    p3d_scene_env_texture(cmds: ICommandsExchangeD3, scene: number, url: IAtom, data_is_image: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number | undefined} [url]
    */
    p3d_scene_shadowmap(cmds: ICommandsExchangeD3, scene: number, url?: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {boolean} display
    * @param {number} pass
    */
    p3d_scene_boundingbox(cmds: ICommandsExchangeD3, scene: number, display: boolean, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} node
    * @param {number} minx
    * @param {number} miny
    * @param {number} minz
    * @param {number} maxx
    * @param {number} maxy
    * @param {number} maxz
    * @param {number} intersection_treshold
    */
    p3d_collider(cmds: ICommandsExchangeD3, node: number, minx: number, miny: number, minz: number, maxx: number, maxy: number, maxz: number, intersection_treshold: number): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} camera
    * @param {number} projectx
    * @param {number} projecty
    * @param {Float32Array} result
    * @returns {boolean}
    */
    p3d_create_pickingray(app: INativeEngine, param: IActionSetScene3D, camera: number, projectx: number, projecty: number, result: Float32Array): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} scene
    * @param {number} viewer
    * @param {number} projectx
    * @param {number} projecty
    * @param {boolean} not_ray_bounding
    * @param {Float64Array} result
    * @returns {boolean}
    */
    p3d_scene_pick(app: INativeEngine, param: IActionSetScene3D, scene: number, viewer: number, projectx: number, projecty: number, not_ray_bounding: boolean, result: Float64Array): boolean;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @returns {number}
    */
    p3d_transform_node(app: INativeEngine, cmds: ICommandsExchangeD3, scene: number): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} node
    * @param {number} parent
    */
    p3d_transform_node_parent(cmds: ICommandsExchangeD3, node: number, parent: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {Float64Array} data
    * @param {number} len
    */
    p3d_transform_node_parent_arr(cmds: ICommandsExchangeD3, data: Float64Array, len: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} node
    * @param {boolean} val
    */
    p3d_node_enable(cmds: ICommandsExchangeD3, node: number, val: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {Float64Array} data
    * @param {number} len
    */
    p3d_node_enable_arr(cmds: ICommandsExchangeD3, data: Float64Array, len: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} node
    * @param {number} x
    * @param {number} y
    * @param {number} z
    */
    p3d_local_position(cmds: ICommandsExchangeD3, node: number, x: number, y: number, z: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {Float64Array} data
    * @param {number} len
    */
    p3d_local_position_arr(cmds: ICommandsExchangeD3, data: Float64Array, len: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} node
    * @param {number} x
    * @param {number} y
    * @param {number} z
    */
    p3d_local_scaling(cmds: ICommandsExchangeD3, node: number, x: number, y: number, z: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {Float64Array} data
    * @param {number} len
    */
    p3d_local_scaling_arr(cmds: ICommandsExchangeD3, data: Float64Array, len: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} node
    * @param {number} x
    * @param {number} y
    * @param {number} z
    */
    p3d_local_euler(cmds: ICommandsExchangeD3, node: number, x: number, y: number, z: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {Float64Array} data
    * @param {number} len
    */
    p3d_local_euler_arr(cmds: ICommandsExchangeD3, data: Float64Array, len: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} node
    * @param {number} x
    * @param {number} y
    * @param {number} z
    * @param {number} w
    */
    p3d_local_quaternion(cmds: ICommandsExchangeD3, node: number, x: number, y: number, z: number, w: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {Float64Array} data
    * @param {number} len
    */
    p3d_local_quaternion_arr(cmds: ICommandsExchangeD3, data: Float64Array, len: number): void;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @returns {number}
    */
    p3d_camera(app: INativeEngine, cmds: ICommandsExchangeD3, scene: number): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} camera
    * @param {number} size
    */
    p3d_camera_size(cmds: ICommandsExchangeD3, camera: number, size: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} camera
    * @param {number} fov
    */
    p3d_camera_fov(cmds: ICommandsExchangeD3, camera: number, fov: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} camera
    * @param {boolean} active
    */
    p3d_camera_active(cmds: ICommandsExchangeD3, camera: number, active: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} camera
    * @param {boolean} as_orthographic
    */
    p3d_camera_mode(cmds: ICommandsExchangeD3, camera: number, as_orthographic: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} camera
    * @param {boolean} as_horizontal
    */
    p3d_camera_fixed_mode(cmds: ICommandsExchangeD3, camera: number, as_horizontal: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} camera
    * @param {number} x
    * @param {number} y
    * @param {number} z
    */
    p3d_camera_target(cmds: ICommandsExchangeD3, camera: number, x: number, y: number, z: number): void;
    /**
    *
    * 相机渲染像素宽高
    * @param {CommandsExchangeD3} cmds
    * @param {number} camera
    * @param {number} near
    * @param {number} far
    */
    p3d_camera_nearfar(cmds: ICommandsExchangeD3, camera: number, near: number, far: number): void;
    /**
    *
    * 相机宽高比
    * * @tip 传入null值对应 自适应宽高比
    * * @tip 传入正小数 表示自定义宽高比
    * * @example 16/9 16/10 null
    * @param {CommandsExchangeD3} cmds
    * @param {number} camera
    * @param {number | undefined} [val]
    */
    p3d_camera_aspect(cmds: ICommandsExchangeD3, camera: number, val?: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} viewer
    * @param {number} entity
    * @param {boolean} add
    */
    p3d_viewer_force_include(cmds: ICommandsExchangeD3, viewer: number, entity: number, add: boolean): void;
    /**
    * * pass_tag:
    *     * 0b0000_0000_0000_0001
    *     * 0b0000_0000_0000_0010
    *     * 0b0000_0000_0000_0100
    *     * 0b0000_0000_0000_1000
    *     * 0b0000_0000_0001_0000
    *     * 0b0000_0000_0010_0000
    *     * 0b0000_0000_0100_0000
    *     * 0b0000_0000_1000_0000
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} viewer
    * @param {string} name
    * @param {number} pass_tag
    * @param {boolean} transparent
    * @returns {number}
    */
    p3d_create_render(app: INativeEngine, cmds: ICommandsExchangeD3, viewer: number, name: string, pass_tag: number, transparent: boolean): number;
    /**
    * 
    * Renderer Modify
    * @param {CommandsExchangeD3} cmds
    * @param {number} renderer
    * @param {number | undefined} [keytarget]
    */
    p3d_render_target_key(cmds: ICommandsExchangeD3, renderer: number, keytarget?: number): void;
    /**
    * 
    * Renderer Modify
    * @param {CommandsExchangeD3} cmds
    * @param {number} renderer
    * @param {number} width
    * @param {number} height
    * @param {number} colorformat
    * @param {number} depthstencilformat
    */
    p3d_render_target_auto(cmds: ICommandsExchangeD3, renderer: number, width: number, height: number, colorformat: number, depthstencilformat: number): void;
    /**
    * 
    * Renderer Modify
    * @param {CommandsExchangeD3} cmds
    * @param {number} renderer
    * @param {boolean} val
    */
    p3d_render_auto_clear_color(cmds: ICommandsExchangeD3, renderer: number, val: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} renderer
    * @param {boolean} val
    */
    p3d_render_auto_clear_depth(cmds: ICommandsExchangeD3, renderer: number, val: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} renderer
    * @param {boolean} val
    */
    p3d_render_auto_clear_stencil(cmds: ICommandsExchangeD3, renderer: number, val: boolean): void;
    /**
    * r g b a 数值为 0 ~ 255 u8
    * @param {CommandsExchangeD3} cmds
    * @param {number} renderer
    * @param {number} r
    * @param {number} g
    * @param {number} b
    * @param {number} a
    */
    p3d_render_clear_color(cmds: ICommandsExchangeD3, renderer: number, r: number, g: number, b: number, a: number): void;
    /**
    * val 数值为 0.~1.
    * @param {CommandsExchangeD3} cmds
    * @param {number} renderer
    * @param {number} val
    */
    p3d_render_clear_depth(cmds: ICommandsExchangeD3, renderer: number, val: number): void;
    /**
    *
    * val 数值为 u32
    * @param {CommandsExchangeD3} cmds
    * @param {number} renderer
    * @param {number} val
    */
    p3d_render_clear_stencil(cmds: ICommandsExchangeD3, renderer: number, val: number): void;
    /**
    *
    * val 数值为 u32
    * @param {CommandsExchangeD3} cmds
    * @param {number} renderer
    * @param {number} x
    * @param {number} y
    * @param {number} w
    * @param {number} h
    */
    p3d_render_viewport(cmds: ICommandsExchangeD3, renderer: number, x: number, y: number, w: number, h: number): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} color_format
    * @param {number} depth_stencil_format
    * @param {number} width
    * @param {number} height
    * @param {number} filter
    * @param {number} address
    * @param {number} anisotropy_clamp
    * @returns {number | undefined}
    */
    p3d_create_render_target(app: INativeEngine, param: IActionSetScene3D, color_format: number, depth_stencil_format: number, width: number, height: number, filter: number, address: number, anisotropy_clamp: number): number | undefined;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} key
    */
    p3d_dispose_render_target(app: INativeEngine, param: IActionSetScene3D, key: number): void;
    /**
    * @param {VInstanceAttributes} item
    * @param {Atom} key
    * @param {Atom} code
    * @param {Atom} foruniform
    * @param {number} vtype
    */
    p3d_instance_attribute(item: IVInstanceAttributes, key: IAtom, code: IAtom, foruniform: IAtom, vtype: number): void;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {VInstanceAttributes} instancestate
    * @param {boolean} instance_use_single_buffer
    * @returns {number}
    */
    p3d_mesh(app: INativeEngine, cmds: ICommandsExchangeD3, scene: number, instancestate: IVInstanceAttributes, instance_use_single_buffer: boolean): number;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {GeometryMeta} geometa
    * @returns {number}
    */
    p3d_mesh_geometry(app: INativeEngine, cmds: ICommandsExchangeD3, mesh: number, geometa: IGeometryMeta): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number | undefined} [index_start]
    * @param {number | undefined} [index_end]
    */
    p3d_mesh_indexrange(cmds: ICommandsExchangeD3, mesh: number, index_start?: number, index_end?: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number | undefined} [vertex_start]
    * @param {number | undefined} [vertex_count]
    */
    p3d_mesh_vertexrange(cmds: ICommandsExchangeD3, mesh: number, vertex_start?: number, vertex_count?: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} v0
    * @param {number} v1
    * @param {number} v2
    * @param {number} v3
    */
    p3d_mesh_morphtargetinfluence(cmds: ICommandsExchangeD3, mesh: number, v0: number, v1: number, v2: number, v3: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {boolean} enable
    * @param {number} src_color
    * @param {number} dst_color
    * @param {number} src_alpha
    * @param {number} dst_alpha
    * @param {number} opt_color
    * @param {number} opt_alpha
    * @param {number | undefined} [pass]
    */
    p3d_mesh_blend(cmds: ICommandsExchangeD3, mesh: number, enable: boolean, src_color: number, dst_color: number, src_alpha: number, dst_alpha: number, opt_color: number, opt_alpha: number, pass?: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} val
    * @param {number} pass
    */
    p3d_mesh_cull_mode(cmds: ICommandsExchangeD3, mesh: number, val: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} val
    * @param {number} pass
    */
    p3d_mesh_frontface(cmds: ICommandsExchangeD3, mesh: number, val: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} val
    * @param {number} pass
    */
    p3d_mesh_topology(cmds: ICommandsExchangeD3, mesh: number, val: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} val
    * @param {number} pass
    */
    p3d_mesh_polygon_mode(cmds: ICommandsExchangeD3, mesh: number, val: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {boolean} val
    * @param {number} pass
    */
    p3d_mesh_unclip_depth(cmds: ICommandsExchangeD3, mesh: number, val: boolean, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {boolean} val
    * @param {number} pass
    */
    p3d_mesh_cast_shadow(cmds: ICommandsExchangeD3, mesh: number, val: boolean, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {boolean} val
    * @param {number} pass
    */
    p3d_mesh_receive_shadow(cmds: ICommandsExchangeD3, mesh: number, val: boolean, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {boolean} val
    * @param {number} pass
    */
    p3d_mesh_depth_write(cmds: ICommandsExchangeD3, mesh: number, val: boolean, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} val
    * @param {number} pass
    */
    p3d_mesh_depth_compare(cmds: ICommandsExchangeD3, mesh: number, val: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} constant
    * @param {number} slope_scale
    * @param {number} clamp
    * @param {number} pass
    */
    p3d_mesh_depth_bias(cmds: ICommandsExchangeD3, mesh: number, constant: number, slope_scale: number, clamp: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} compare
    * @param {number} fail_op
    * @param {number} depth_fail_op
    * @param {number} pass_op
    * @param {number} pass
    */
    p3d_mesh_stencil_front(cmds: ICommandsExchangeD3, mesh: number, compare: number, fail_op: number, depth_fail_op: number, pass_op: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} compare
    * @param {number} fail_op
    * @param {number} depth_fail_op
    * @param {number} pass_op
    * @param {number} pass
    */
    p3d_mesh_stencil_back(cmds: ICommandsExchangeD3, mesh: number, compare: number, fail_op: number, depth_fail_op: number, pass_op: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} val
    * @param {number} pass
    */
    p3d_mesh_stencil_read(cmds: ICommandsExchangeD3, mesh: number, val: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} val
    * @param {number} pass
    */
    p3d_mesh_stencil_write(cmds: ICommandsExchangeD3, mesh: number, val: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} minx
    * @param {number} miny
    * @param {number} minz
    * @param {number} maxx
    * @param {number} maxy
    * @param {number} maxz
    */
    p3d_mesh_bounding_box(cmds: ICommandsExchangeD3, mesh: number, minx: number, miny: number, minz: number, maxx: number, maxy: number, maxz: number): void;
    /**
    *
    * * `mode` = `1`: ECullingStrategy::Optimistic
    * * `mode` = `2`: ECullingStrategy::STANDARD
    * * `mode` = `_`: ECullingStrategy::None
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} mode
    */
    p3d_mesh_bounding_cullingmode(cmds: ICommandsExchangeD3, mesh: number, mode: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} group
    * @param {number} index
    */
    p3d_mesh_render_queue(cmds: ICommandsExchangeD3, mesh: number, group: number, index: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {Float64Array} data
    * @param {number} len
    */
    p3d_mesh_render_queue_arr(cmds: ICommandsExchangeD3, data: Float64Array, len: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} val
    */
    p3d_mesh_render_alignment(cmds: ICommandsExchangeD3, mesh: number, val: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} val
    */
    p3d_abstruct_mesh_scaling_mode(cmds: ICommandsExchangeD3, mesh: number, val: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {number} x
    * @param {number} y
    * @param {number} z
    */
    p3d_abstruct_mesh_velocity(cmds: ICommandsExchangeD3, mesh: number, x: number, y: number, z: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {Float64Array} data
    * @param {number} len
    */
    p3d_abstruct_mesh_velocity_arr(cmds: ICommandsExchangeD3, data: Float64Array, len: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} abstructmesh
    * @param {number} group
    * @param {Atom} key
    * @param {number} curve_key
    */
    p3d_attribute_target_animation(cmds: ICommandsExchangeD3, abstructmesh: number, group: number, key: IAtom, curve_key: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh
    * @param {Float32Array} data
    */
    p3d_abstruct_pose_matrix(cmds: ICommandsExchangeD3, mesh: number, data: Float32Array): void;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} source
    * @returns {number}
    */
    p3d_instance_mesh(app: INativeEngine, cmds: ICommandsExchangeD3, source: number): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} uscale
    * @param {number} vscale
    * @param {number} uoffset
    * @param {number} voffset
    * @param {Atom} attr
    */
    p3d_instance_mesh_vec4(cmds: ICommandsExchangeD3, instance: number, uscale: number, vscale: number, uoffset: number, voffset: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} r
    * @param {number} g
    * @param {number} b
    * @param {Atom} attr
    */
    p3d_instance_mesh_vec3(cmds: ICommandsExchangeD3, instance: number, r: number, g: number, b: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} x
    * @param {number} y
    * @param {Atom} attr
    */
    p3d_instance_mesh_vec2(cmds: ICommandsExchangeD3, instance: number, x: number, y: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} val
    * @param {Atom} attr
    */
    p3d_instance_mesh_float(cmds: ICommandsExchangeD3, instance: number, val: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} x
    * @param {Atom} attr
    */
    p3d_instance_mesh_sint(cmds: ICommandsExchangeD3, instance: number, x: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} x
    * @param {Atom} attr
    */
    p3d_instance_mesh_uint(cmds: ICommandsExchangeD3, instance: number, x: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} x
    * @param {number} y
    * @param {number} z
    * @param {number} w
    * @param {Atom} attr
    */
    p3d_instance_mesh_ivec4(cmds: ICommandsExchangeD3, instance: number, x: number, y: number, z: number, w: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} x
    * @param {number} y
    * @param {Atom} attr
    */
    p3d_instance_mesh_u16x2(cmds: ICommandsExchangeD3, instance: number, x: number, y: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} x
    * @param {number} y
    * @param {number} z
    * @param {number} w
    * @param {Atom} attr
    */
    p3d_instance_mesh_u16x4(cmds: ICommandsExchangeD3, instance: number, x: number, y: number, z: number, w: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} x
    * @param {number} y
    * @param {number} z
    * @param {number} w
    * @param {Atom} attr
    */
    p3d_instance_mesh_u8x4(cmds: ICommandsExchangeD3, instance: number, x: number, y: number, z: number, w: number, attr: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} instance
    * @param {number} val
    */
    p3d_mesh_bone_offset(cmds: ICommandsExchangeD3, instance: number, val: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {Float64Array} data
    * @param {number} len
    */
    p3d_mesh_bone_offset_arr(cmds: ICommandsExchangeD3, data: Float64Array, len: number): void;
    /**
    * @param {VBMeta} meta
    * @param {number} attr
    * @param {number} format
    */
    p3d_vbmeta_attr(meta: IVBMeta, attr: number, format: number): void;
    /**
    * @param {VBMeta} meta
    * @param {Atom} key
    * @param {number} format
    * @param {Atom} code
    * @param {Atom} foruniform
    */
    p3d_vbmeta_custom_attr(meta: IVBMeta, key: IAtom, format: number, code: IAtom, foruniform: IAtom): void;
    /**
    * @param {GeometryMeta} geo
    * @param {VBMeta} vb
    */
    p3d_geo_set_vertex(geo: IGeometryMeta, vb: IVBMeta): void;
    /**
    * @param {GeometryMeta} geo
    * @param {string} name
    * @param {number | undefined} start
    * @param {number | undefined} end
    * @param {boolean} as_u16
    */
    p3d_geo_set_indice(geo: IGeometryMeta, name: string, start: number | undefined, end: number | undefined, as_u16: boolean): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {string} key
    * @param {Float32Array} data
    * @param {number} length
    */
    p3d_create_vertex_buffer(app: INativeEngine, param: IActionSetScene3D, key: string, data: Float32Array, length: number): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {string} key
    * @param {Uint16Array} data
    * @param {number} length
    */
    p3d_create_indices_buffer(app: INativeEngine, param: IActionSetScene3D, key: string, data: Uint16Array, length: number): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {string} key
    * @param {Uint32Array} data
    * @param {number} length
    */
    p3d_create_indices_buffer_u32(app: INativeEngine, param: IActionSetScene3D, key: string, data: Uint32Array, length: number): void;
    /**
    * @param {Engine} app
    * @returns {number}
    */
    p3d_material(app: INativeEngine): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {Atom} shader
    */
    p3d_material_shader(cmds: ICommandsExchangeD3, mat: number, shader: IAtom): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {number} mesh
    * @param {number} pass
    */
    p3d_material_apply(cmds: ICommandsExchangeD3, mat: number, mesh: number, pass: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {Atom} key
    * @param {number} m11
    * @param {number} m12
    * @param {number} m13
    * @param {number} m14
    * @param {number} m21
    * @param {number} m22
    * @param {number} m23
    * @param {number} m24
    * @param {number} m31
    * @param {number} m32
    * @param {number} m33
    * @param {number} m34
    * @param {number} m41
    * @param {number} m42
    * @param {number} m43
    * @param {number} m44
    */
    p3d_material_uniform_mat4(cmds: ICommandsExchangeD3, mat: number, key: IAtom, m11: number, m12: number, m13: number, m14: number, m21: number, m22: number, m23: number, m24: number, m31: number, m32: number, m33: number, m34: number, m41: number, m42: number, m43: number, m44: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {Atom} key
    * @param {number} x
    * @param {number} y
    */
    p3d_material_uniform_vec2(cmds: ICommandsExchangeD3, mat: number, key: IAtom, x: number, y: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {Atom} key
    * @param {number} x
    * @param {number} y
    * @param {number} z
    * @param {number} w
    */
    p3d_material_uniform_vec4(cmds: ICommandsExchangeD3, mat: number, key: IAtom, x: number, y: number, z: number, w: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {Atom} key
    * @param {number} val
    */
    p3d_material_uniform_float(cmds: ICommandsExchangeD3, mat: number, key: IAtom, val: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {Atom} key
    * @param {number} val
    */
    p3d_material_uniform_uint(cmds: ICommandsExchangeD3, mat: number, key: IAtom, val: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {Atom} key
    * @param {Atom} url
    * @param {boolean} srgb
    * @param {boolean} compressed
    * @param {boolean} filter
    * @param {number} address_mode_u
    * @param {number} address_mode_v
    * @param {number} address_mode_w
    * @param {number} mag_filter
    * @param {number} min_filter
    * @param {number} mipmap_filter
    * @param {number} anisotropy_clamp
    * @param {number} border_color
    * @param {number | undefined} [compare]
    */
    p3d_material_uniform_tex(cmds: ICommandsExchangeD3, mat: number, key: IAtom, url: IAtom, srgb: boolean, compressed: boolean, filter: boolean, address_mode_u: number, address_mode_v: number, address_mode_w: number, mag_filter: number, min_filter: number, mipmap_filter: number, anisotropy_clamp: number, border_color: number, isfile: boolean, cancombine: boolean, compare?: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {Atom} key
    * @param {Atom} key_tilloff
    * @param {number} url
    * @param {boolean} filter
    * @param {number} address_mode_u
    * @param {number} address_mode_v
    * @param {number} address_mode_w
    * @param {number} mag_filter
    * @param {number} min_filter
    * @param {number} mipmap_filter
    * @param {number} anisotropy_clamp
    * @param {number} border_color
    * @param {number | undefined} [compare]
    */
    p3d_material_uniform_tex_from_render_target(cmds: ICommandsExchangeD3, mat: number, key: IAtom, key_tilloff: IAtom, url: number, filter: boolean, address_mode_u: number, address_mode_v: number, address_mode_w: number, mag_filter: number, min_filter: number, mipmap_filter: number, anisotropy_clamp: number, border_color: number, compare?: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mat
    * @param {number} group
    * @param {Atom} key
    * @param {number} curve_key
    */
    p3d_uniform_target_animation(cmds: ICommandsExchangeD3, mat: number, group: number, key: IAtom, curve_key: number): void;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} ltype
    * @returns {number}
    */
    p3d_light(app: INativeEngine, cmds: ICommandsExchangeD3, scene: number, ltype: number): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} light
    * @param {number} x
    * @param {number} y
    * @param {number} z
    */
    p3d_light_direction(cmds: ICommandsExchangeD3, light: number, x: number, y: number, z: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} light
    * @param {number} val
    */
    p3d_light_strength(cmds: ICommandsExchangeD3, light: number, val: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} light
    * @param {number} inner
    * @param {number} outer
    */
    p3d_light_spot_angle(cmds: ICommandsExchangeD3, light: number, inner: number, outer: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} light
    * @param {number} val
    */
    p3d_light_radius(cmds: ICommandsExchangeD3, light: number, val: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} light
    * @param {number} r
    * @param {number} g
    * @param {number} b
    */
    p3d_light_color(cmds: ICommandsExchangeD3, light: number, r: number, g: number, b: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh_or_instance
    * @param {number} light
    * @param {boolean} is_add
    */
    p3d_abstructmesh_force_point_light(cmds: ICommandsExchangeD3, mesh_or_instance: number, light: number, is_add: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh_or_instance
    * @param {number} light
    * @param {boolean} is_add
    */
    p3d_abstructmesh_force_spot_light(cmds: ICommandsExchangeD3, mesh_or_instance: number, light: number, is_add: boolean): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} mesh_or_instance
    * @param {number} light
    * @param {boolean} is_add
    */
    p3d_abstructmesh_force_hemi_light(cmds: ICommandsExchangeD3, mesh_or_instance: number, light: number, is_add: boolean): void;
    /**
    * * pass_tag:
    *     * 0b0000_0000_0000_0001
    *     * 0b0000_0000_0000_0010
    *     * 0b0000_0000_0000_0100
    *     * 0b0000_0000_0000_1000
    *     * 0b0000_0000_0001_0000
    *     * 0b0000_0000_0010_0000
    *     * 0b0000_0000_0100_0000
    *     * 0b0000_0000_1000_0000
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} light
    * @param {number} pass_tag
    * @returns {number}
    */
    p3d_shadow_generator(app: INativeEngine, cmds: ICommandsExchangeD3, scene: number, light: number, pass_tag: number): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} shadow
    * @param {number} bias
    * @param {number} normal_bias
    * @param {number} depthscale
    * @returns {number}
    */
    p3d_shadow_base_param(cmds: ICommandsExchangeD3, shadow: number, bias: number, normal_bias: number, depthscale: number): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} shadow
    * @param {number} frustum_size
    * @param {number} minz
    * @param {number} maxz
    */
    p3d_shadow_frustum(cmds: ICommandsExchangeD3, shadow: number, frustum_size: number, minz: number, maxz: number): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {Atom} depend
    */
    p3d_node_material_block_extend_depend(block: INodeMaterialBlock, depend: IAtom): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {number} bind_define
    */
    p3d_node_material_block_extend_bind_define(block: INodeMaterialBlock, bind_define: number): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {Atom} key
    * @param {number} m11
    * @param {number} m12
    * @param {number} m13
    * @param {number} m14
    * @param {number} m21
    * @param {number} m22
    * @param {number} m23
    * @param {number} m24
    * @param {number} m31
    * @param {number} m32
    * @param {number} m33
    * @param {number} m34
    * @param {number} m41
    * @param {number} m42
    * @param {number} m43
    * @param {number} m44
    */
    p3d_node_material_block_mat4(block: INodeMaterialBlock, key: IAtom, m11: number, m12: number, m13: number, m14: number, m21: number, m22: number, m23: number, m24: number, m31: number, m32: number, m33: number, m34: number, m41: number, m42: number, m43: number, m44: number): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {Atom} key
    * @param {number} x
    * @param {number} y
    * @param {number} z
    * @param {number} w
    * @param {boolean} caninstance
    */
    p3d_node_material_block_vec4(block: INodeMaterialBlock, key: IAtom, x: number, y: number, z: number, w: number, caninstance: boolean): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {Atom} key
    * @param {number} x
    * @param {number} y
    * @param {number} z
    * @param {boolean} caninstance
    */
    p3d_node_material_block_vec3(block: INodeMaterialBlock, key: IAtom, x: number, y: number, z: number, caninstance: boolean): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {Atom} key
    * @param {number} x
    * @param {number} y
    * @param {boolean} caninstance
    */
    p3d_node_material_block_vec2(block: INodeMaterialBlock, key: IAtom, x: number, y: number, caninstance: boolean): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {Atom} key
    * @param {number} x
    * @param {boolean} caninstance
    */
    p3d_node_material_block_float(block: INodeMaterialBlock, key: IAtom, x: number, caninstance: boolean): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {Atom} key
    * @param {number} x
    * @param {boolean} caninstance
    */
    p3d_node_material_block_uint(block: INodeMaterialBlock, key: IAtom, x: number, caninstance: boolean): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {Atom} name
    * @param {Atom} format
    */
    p3d_node_material_block_varying(block: INodeMaterialBlock, name: IAtom, format: IAtom): void;
    /**
    * @param {NodeMaterialBlock} block
    * @param {Atom} key
    * @param {boolean} filterable
    * @param {number} stage
    * @param {number} default_texture
    * @param {number} demision
    */
    p3d_node_material_block_texture(block: INodeMaterialBlock, key: IAtom, filterable: boolean, stage: number, default_texture: number, demision: number): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {NodeMaterialBlock} block
    */
    p3d_node_material_block_regist(app: INativeEngine, param: IActionSetScene3D, block: INodeMaterialBlock): void;
    /**
    * @param {NodematerialIncludes} includes
    * @param {BuiltinNodeMaterialBlock} block
    */
    p3d_material_include(includes: INodematerialIncludes, block: _BuiltinNodeMaterialBlock | number): void;
    /**
    * @param {NodematerialIncludes} includes
    * @param {Atom} block
    */
    p3d_material_include_by_name(includes: INodematerialIncludes, block: IAtom): void;
    /**
    * @param {NodematerialIncludes} includes
    */
    p3d_material_includes_reset(includes: INodematerialIncludes): void;
    /**
    * @param {MaterialUniformDefines} uniforms
    * @param {string} key
    * @param {number} val
    * @param {boolean} caninstance
    */
    p3d_shader_uniform_float(uniforms: IMaterialUniformDefines, key: string, val: number, caninstance: boolean): void;
    /**
    * @param {MaterialUniformDefines} uniforms
    * @param {string} key
    * @param {number} x
    * @param {number} y
    * @param {boolean} caninstance
    */
    p3d_shader_uniform_vec2(uniforms: IMaterialUniformDefines, key: string, x: number, y: number, caninstance: boolean): void;
    /**
    * @param {MaterialUniformDefines} uniforms
    * @param {string} key
    * @param {number} x
    * @param {number} y
    * @param {number} z
    * @param {number} w
    * @param {boolean} caninstance
    */
    p3d_shader_uniform_vec4(uniforms: IMaterialUniformDefines, key: string, x: number, y: number, z: number, w: number, caninstance: boolean): void;
    /**
    * @param {MaterialUniformDefines} uniforms
    * @param {string} key
    * @param {number} val
    * @param {boolean} caninstance
    */
    p3d_shader_uniform_uint(uniforms: IMaterialUniformDefines, key: string, val: number, caninstance: boolean): void;
    /**
    * @param {MaterialUniformDefines} uniforms
    * @param {string} key
    * @param {boolean} filterable
    * @param {number} stage
    * @param {number} default_texture
    * @param {number} demision
    */
    p3d_shader_uniform_tex(uniforms: IMaterialUniformDefines, key: string, filterable: boolean, stage: number, default_texture: number, demision: number): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {string} key
    * @returns {boolean}
    */
    p3d_check_shader(app: INativeEngine, param: IActionSetScene3D, key: string): boolean;
    /**
    * @param {P3DShaderVaryings} block
    * @param {Atom} name
    * @param {Atom} format
    */
    p3d_varying(block: IP3DShaderVaryings, name: IAtom, format: IAtom): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {string} key
    * @param {MaterialUniformDefines} uniforms
    * @param {string} vs_define_code
    * @param {string} fs_define_code
    * @param {string} vs_code
    * @param {string} fs_code
    * @param {NodematerialIncludes} includes
    * @param {string} instance_code
    * @param {P3DShaderVaryings} varyings
    * @param {number | undefined} [binds_defines_base]
    * @returns {P3DShaderMeta | undefined}
    */
    p3d_regist_material(app: INativeEngine, param: IActionSetScene3D, key: string, uniforms: IMaterialUniformDefines, vs_define_code: string, fs_define_code: string, vs_code: string, fs_code: string, includes: INodematerialIncludes, instance_code: string, varyings: IP3DShaderVaryings, binds_defines_base?: number): IP3DShaderMeta | undefined;
    /**
    * @param {CommandsExchangeD3} param
    * @param {Atom} key
    * @param {number} width
    * @param {number} height
    * @param {number} format
    * @param {number | undefined} [aspect]
    */
    p3d_create_data_texture(param: ICommandsExchangeD3, key: IAtom, width: number, height: number, format: number, aspect?: number): void;
    /**
    * @param {CommandsExchangeD3} param
    * @param {Atom} key
    * @param {Uint8Array} data
    * @param {number} xoffset
    * @param {number} yoffset
    * @param {number} width
    * @param {number} height
    * @param {number | undefined} [aspect]
    */
    p3d_update_data_texture(param: ICommandsExchangeD3, key: IAtom, data: Uint8Array, xoffset: number, yoffset: number, width: number, height: number, aspect?: number): void;

    /**
    * @param {CommandsExchangeD3} cmd
    * @param {Atom} key
    */
    p3d_remove_data_texture(cmd: ICommandsExchangeD3, key: IAtom): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {boolean} isfile
    * @param {Atom} url
    * @param {boolean} srgb
    * @param {boolean} compressed
    * @param {number} depth_or_array_layers
    * @param {number} useage
    * @param {Float32Array} info
    * @returns {boolean}
    */
    p3d_query_texture(app: INativeEngine, param: IActionSetScene3D, isfile: boolean, url: IAtom, cancombine: boolean, compressed: boolean, depth_or_array_layers: number, info: Float32Array): boolean;
    /**
    * @param {CommandsExchangeD3} cmd
    * @param {number} requestid
    * @param {Atom} targetkey
    * @param {Atom} file
    * @param {number} idx
    * @param {boolean} iscompress
    * @param {number} xoffset
    * @param {number} yoffset
    * @param {number} width
    * @param {number} height
    */
    p3d_texture_combine_add_frame(cmd: ICommandsExchangeD3, requestid: number, targetkey: IAtom, file: IAtom, idx: number, iscompress: boolean, xoffset: number, yoffset: number, width: number, height: number): void;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmd
    * @param {number} requestid
    * @param {Atom} targetkey
    */
    p3d_texture_combine_remove(app: INativeEngine, cmd: ICommandsExchangeD3, requestid: number, targetkey: IAtom): void;
    /**
    * @param {Engine} app
    * @param {Uint32Array} success
    * @param {Uint32Array} fail
    */
    p3d_texture_combine_query(app: INativeEngine, success: Uint32Array, fail: Uint32Array): void;
    /**
    * @param {Engine} app
    * @param {number} format
    * @param {number} maxlayer
    * @param {number} maxsize
    * @param {number} maxcount
    */
    p3d_texture_combine_param(app: INativeEngine, format: number, maxlayer: number, maxsize: number, maxcount: number): void;
    /**
    * 创建动画组
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @returns {number}
    */
    p3d_animation_group(app: INativeEngine, cmds: ICommandsExchangeD3, scene: number): number;
    /**
    * 动画曲线ID
    * @param {Atom} key
    * @returns {number}
    */
    p3d_animation_curve_id(key: IAtom): number;
    /**
    * 设置 动画组 混合权重
    * @param {CommandsExchangeD3} cmds
    * @param {number} group
    * @param {number} weight
    */
    p3d_animation_group_weight(cmds: ICommandsExchangeD3, group: number, weight: number): void;
    /**
    * 重置动画组各动画作用目标到非动画操作状态
    * @param {CommandsExchangeD3} cmds
    * @param {number} group
    */
    p3d_animation_group_target_reset(cmds: ICommandsExchangeD3, group: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} group_key
    * @param {number} speed
    * @param {ELoopMode} loop_mode
    * @param {number | undefined} loop_count
    * @param {number} from
    * @param {number} to
    * @param {number} fps
    * @param {EAmountMode} amount_mode
    * @param {number} delay_ms
    * @param {EFillMode} fillmode
    * @param {number} amount_param0
    * @param {number} amount_param1
    * @param {number} amount_param2
    * @param {number} amount_param3
    */
    p3d_anime_group_start(cmds: ICommandsExchangeD3, group_key: number, speed: number, loop_mode: _ELoopMode, loop_count: number | undefined, from: number, to: number, fps: number, amount_mode: _EAmountMode | number, delay_ms: number, fillmode: _EFillMode, amount_param0: number, amount_param1: number, amount_param2: number, amount_param3: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} group_key
    */
    p3d_anime_group_pause(cmds: ICommandsExchangeD3, group_key: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} group_key
    */
    p3d_anime_group_stop(cmds: ICommandsExchangeD3, group_key: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} group_key
    * @param {number} amount
    */
    p3d_anime_group_goto(cmds: ICommandsExchangeD3, group_key: number, amount: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} group_key
    * @param {EAnimationGroupListen} mode
    */
    p3d_animation_group_listen(cmds: ICommandsExchangeD3, group_key: number, mode: _EAnimationGroupListen | number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} group
    * @param {number} percent
    * @param {number} data
    */
    p3d_animation_group_add_frame_event(cmds: ICommandsExchangeD3, group: number, percent: number, data: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} group
    */
    p3d_animation_group_delete(cmds: ICommandsExchangeD3, group: number): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {Float64Array} receive
    * @param {number} receive_len
    * @returns {number}
    */
    p3d_query_anime_events(app: INativeEngine, param: IActionSetScene3D, receive: Float64Array, receive_len: number): number;
    /**
    * FrameCurve
    * * `FrameValues` data: [design_frame_per_second, (frame, x, y, ..), (frame, x, y, ..) ...]
    * * `FrameValuesStep` data: [design_frame_per_second, (frame, x, y, ..), (frame, x, y, ..) ...]
    * * `EasingCurve` data: [design_frame_per_second, total_frame, mode, (x, y, ..), (x, y, ..)]
    * * `MinMaxCurve` data: [design_frame_per_second, (x, y, ..), (x, y, ..), (frame, f32, it, ot), (frame, f32, it, ot) ...]
    * * `CubicBezierCurve` data: [design_frame_per_second, total_frame, (x, y, ..), (x, y, ..), (x1, y1, x2, y2)]
    * * `GLTFCubicSpline` data: [design_frame_per_second, (frame, (x, y, ..), (x, y, ..), (x, y, ..)), ...]
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} key
    * @param {EAnimePropertyID} property
    * @returns {boolean}
    */
    p3d_anime_curve_query(app: INativeEngine, param: IActionSetScene3D, key: number, property: _EAnimePropertyID): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {number} key
    * @param {EAnimePropertyID} property
    * @param {Float32Array} data
    * @param {EAnimeCurve} mode
    * @returns {boolean}
    */
    p3d_anime_curve_create(app: INativeEngine, param: IActionSetScene3D, key: number, property: _EAnimePropertyID, data: Float32Array, mode: _EAnimeCurve): boolean;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} curve_key
    * @param {EAnimePropertyID} property
    * @param {number} group
    * @param {number} curve_target
    * @returns {boolean}
    */
    p3d_property_target_animation(cmds: ICommandsExchangeD3, curve_key: number, property: _EAnimePropertyID, group: number, curve_target: number): boolean;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} entity
    * @param {number} trailmesh
    * @param {number} trailgeo
    * @param {Atom} key
    * @param {Atom} color_attr_key
    * @param {Atom} tilloff_attr_key
    * @param {number | undefined} [update_buffer_interval_frame]
    */
    p3d_particle_system(app: INativeEngine, param: IActionSetScene3D, cmds: ICommandsExchangeD3, scene: number, entity: number, trailmesh: number, trailgeo: number, key: IAtom, color_attr_key: IAtom, tilloff_attr_key: IAtom, update_buffer_interval_frame?: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} entity
    * @param {number} trailmesh
    * @param {number} trailgeo
    * @param {GLTFRes} gltf
    * @param {number} index_calculator
    * @param {Atom} color_attr_key
    * @param {Atom} tilloff_attr_key
    * @param {number | undefined} [update_buffer_interval_frame]
    */
    p3d_particle_system_with_gltf(cmds: ICommandsExchangeD3, scene: number, entity: number, trailmesh: number, trailgeo: number, gltf: IGLTFRes, index_calculator: number, color_attr_key: IAtom, tilloff_attr_key: IAtom, update_buffer_interval_frame?: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} entity
    */
    p3d_particle_system_start(cmds: ICommandsExchangeD3, entity: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} entity
    * @param {number} speed
    */
    p3d_particle_system_timescale(cmds: ICommandsExchangeD3, entity: number, speed: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} entity
    */
    p3d_particle_system_stop(cmds: ICommandsExchangeD3, entity: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @param {number} entity
    * @param {number} linked
    */
    p3d_trail(cmds: ICommandsExchangeD3, scene: number, entity: number, linked: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} entity
    * @param {number} age_ms
    */
    p3d_trail_age(cmds: ICommandsExchangeD3, entity: number, age_ms: number): void;
    /**
    * @param {Engine} app
    * @param {ActionSetScene3D} param
    * @param {CommandsExchangeD3} cmds
    */
    p3d_commands_exchange(app: INativeEngine, param: IActionSetScene3D, cmds: ICommandsExchangeD3): void;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} bonespervertex
    * @param {number} root
    * @param {Float64Array} bones
    * @param {number} bonecount
    * @param {number} cacheframe
    * @returns {number}
    */
    p3d_skeleton(app: INativeEngine, cmds: ICommandsExchangeD3, bonespervertex: number, root: number, bones: Float64Array, bonecount: number, cacheframe: number): number;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} scene
    * @returns {number}
    */
    p3d_bone(app: INativeEngine, cmds: ICommandsExchangeD3, scene: number): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} bone
    * @param {number} link
    */
    p3d_bone_link(cmds: ICommandsExchangeD3, bone: number, link: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} bone
    * @param {Float32Array} data
    */
    p3d_bone_pose(cmds: ICommandsExchangeD3, bone: number, data: Float32Array): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} id_mesh
    * @param {number} skin
    */
    p3d_skin_use(cmds: ICommandsExchangeD3, id_mesh: number, skin: number): void;
    /**
    * @param {Engine} app
    * @param {CommandsExchangeD3} cmds
    * @param {number} source
    * @param {Atom} atlas
    * @returns {number}
    */
    p3d_sprite(app: INativeEngine, cmds: ICommandsExchangeD3, source: number, atlas: IAtom): number;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} sprite
    * @param {number} idxframe
    */
    p3d_sprite_frame(cmds: ICommandsExchangeD3, sprite: number, tilloffkey: IAtom, idxframe: number): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} sprite
    * @param {Uint16Array} data
    */
    p3d_sprite_frame_data(cmds: ICommandsExchangeD3, sprite: number, tilloffkey: IAtom, data: Uint16Array): void;
    /**
    * @param {CommandsExchangeD3} cmds
    * @param {number} sprite
    * @param {Uint16Array} data
    */
    p3d_record_sprite_frame_data(cmds: ICommandsExchangeD3, data: Uint16Array): number;
    /**
    * @param {Atom} atlas
    * @param {number} width
    * @param {number} height
    * @returns {PTextureFrameAtlas}
    */
    p3d_texture_frame_atlas(atlas: IAtom, width: number, height: number): IPTextureFrameAtlas;
    /**
    * @param {PTextureFrameAtlas} atlas
    * @param {Atom} frame_name
    * @param {Uint32Array} framedata
    * @returns {number}
    */
    p3d_texture_frame_atlas_append_frame(atlas: IPTextureFrameAtlas, frame_name: IAtom, framedata: Uint32Array): number;
    /**
    * @param {PTextureFrameAtlas} atlas
    * @param {Atom} anim_name
    * @param {Uint16Array} animframeidxs
    * @returns {number}
    */
    p3d_texture_frame_atlas_append_animation(atlas: IPTextureFrameAtlas, anim_name: IAtom, animframeidxs: Uint16Array): number;
    /**
    * @param {Engine} app
    * @param {PTextureFrameAtlas} atlas
    * @returns {ResTextureFrameAtlas | undefined}
    */
    p3d_texture_frame_atlas_cache(app: INativeEngine, atlas: IPTextureFrameAtlas): IResTextureFrameAtlas | undefined;
    /**
    */
    EFillMode: _EFillMode;
    /**
    */
    BlendMode: _BlendMode;
    /**
    */
    Direction: _Direction;
    /**
    */
    KeySpineShader: _KeySpineShader;
    /**
    */
    EAnimeCurve: _EAnimeCurve;
    /**
    */
    TraceOption: _TraceOption;
    /**
    */
    EAnimePropertyID: _EAnimePropertyID;
    /**
    */
    TileFlagType: _TileFlagType;
    /**
    * blocks.regist::<(.*)>\(\);
    */
    BuiltinNodeMaterialBlock: _BuiltinNodeMaterialBlock;
    /**
    */
    ELoopMode: _ELoopMode;
    /**
    */
    EAmountMode: _EAmountMode;
    /**
    * Initializes the global logger setting `max_log_level` to the given value.
    */
    Level: _Level;
    /**
    */
    EAnimationGroupListen: _EAnimationGroupListen;
    CommandsExchangeD3: _CommandsExchangeD3;
    CommandsExchangeSpine: _CommandsExchangeSpine;
    GeometryMeta: _GeometryMeta;
    VBMeta: _VBMeta;
    VInstanceAttributes: _VInstanceAttributes;
    MaterialUniformDefines: _MaterialUniformDefines;
    NodeMaterialBlock: _NodeMaterialBlock;
    NodematerialIncludes: _NodematerialIncludes;
    P3DShaderVaryings: _P3DShaderVaryings;
    ActionSetScene3D: _ActionSetScene3D;
}

export let p3d: IEngineAPI;