import { BABYLON } from "../render3d/babylon";
import { Arrow, ArrowInstance } from "./arrow";

export class AxisDragGizmo {
    arrow: Arrow;
    constructor(public readonly scene: BABYLON.Scene) {
        this.arrow = new Arrow("AxisDragGizmo", scene);
    }

    /** @hidden */
    public static _CreateArrowInstance(scene: BABYLON.Scene, arrow: Arrow): ArrowInstance {
        const instance = new ArrowInstance("arrow", scene);
        // for (const mesh of arrow.getChildMeshes()) {
        //     const childInstance = (mesh as BABYLON.Mesh).createInstance(mesh.name);
        //     childInstance.parent = instance;
        // }
        
        instance.lineMesh = (arrow.lineMesh as BABYLON.Mesh).createInstance(arrow.lineMesh.name);
        instance.lineMesh.parent = instance;
        instance.lineMesh.alwaysSelectAsActiveMesh = true;
    
        return instance;
    }
}