import { IMainOpacityMaterial } from "../interface";
import { LoadExtraMaterial } from "./material";
import { Material, MainOpacityMaterial, Color3 } from "../../render/index";
import { IRenderState, LoaderRecord } from "../base";
import { StandardEffectMaterial } from "../../render/materials/standard_effect_material";

export class MaterialLoaderMainOpacity {
    public static init() {
        LoadExtraMaterial.regist(
            "main_opacity",
            MaterialLoaderMainOpacity.load
        );
    }
    public static load(loaders: LoaderRecord, info: IMainOpacityMaterial, indexNode: number, callback: (mat: Material, state: IRenderState) => void): Material {

            // StandardEffectMaterial.regist();
            // let mat = new StandardEffectMaterial("Mat", loaders.scene);
            MainOpacityMaterial.regist();
            let mat = new MainOpacityMaterial("Mat", loaders.scene, undefined, loaders.scene.queryPassTag(info.renderQueue || 3000));

            if (info.diffuseTexture) {
                LoadExtraMaterial.diffuseTexture(mat, loaders, indexNode, info);
            }

            // if (info.emissionTexture) {
            //     LoadExtraMaterial.emissiveTexture(mat, loaders, indexNode, info);
            // }

            if (info.opacityTexture) {
                LoadExtraMaterial.opacityTexture(mat, loaders, indexNode, info);
            }

            let numbers = info.diffuseColor;
            // if (numbers) {
            //     mat.diffuseColor = new Color3(numbers[0], numbers[1], numbers[2]);
            // }
            numbers = info.emissionColor;
            if (numbers) {
                mat.diffuseColor = new Color3(numbers[0], numbers[1], numbers[2]);
            }

            let state = LoadExtraMaterial.state(mat, info);

            callback(mat, state);

            return mat;
    }
}