import { IMainOpacityOpacityFresnelMaterial } from "../interface";
import { LoadExtraMaterial } from "./material";
import { Material, Color3, MainOpacityOpacityFresnelMaterial } from "../../render/index";
import { IRenderState, LoaderRecord } from "../base";
import { StandardEffectMaterial } from "../../render/materials/standard_effect_material";

export class MaterialLoaderMainOpacityOpacityFresnel {
    public static init() {
        LoadExtraMaterial.regist(
            "main_opacity_opacity_fresnel",
            MaterialLoaderMainOpacityOpacityFresnel.load
        );
    }
    public static load(loaders: LoaderRecord, info: IMainOpacityOpacityFresnelMaterial, indexNode: number, callback: (mat: Material, state: IRenderState) => void): Material {

            StandardEffectMaterial.regist();
            let mat = new StandardEffectMaterial("Mat", loaders.scene, loaders.scene.queryPassTag(info.renderQueue || 3000));
            // MainOpacityOpacityFresnelMaterial.regist();
            // let mat = new MainOpacityOpacityFresnelMaterial("Mat", loaders.scene);

            if (info.diffuseTexture) {
                LoadExtraMaterial.diffuseTexture(mat, loaders, indexNode, info);
            }

            // if (info.emissionTexture) {
            //     LoadExtraMaterial.emissiveTexture(mat, loaders, indexNode, info);
            // }

            if (info.opacityTexture) {
                LoadExtraMaterial.opacityTexture(mat, loaders, indexNode, info);
            }

            let numbers = info.diffuseColor;
            // if (numbers) {
            //     mat.diffuseColor = new Color3(numbers[0], numbers[1], numbers[2]);
            // }
            numbers = info.emissionColor;
            if (numbers) {
                mat.diffuseColor = new Color3(numbers[0], numbers[1], numbers[2]);
            }

            mat.opacityFresnelParameters.bias = info.OFBias;
            mat.opacityFresnelParameters.power = info.OFPower;
            mat.opacityFresnelParameters.leftColor = new Color3(...info.OFLeft);
            mat.opacityFresnelParameters.rightColor = new Color3(...info.OFRight);

            
            let state = LoadExtraMaterial.state(mat, info);

            callback(mat, state);

            return mat;
    }
}