import { IMainOpacityMaterial, IMaterialDataNew } from "../interface";
import { IRenderState, LoaderRecord } from "../interface/index";
import { LoadExtraMaterial } from "./material";
import { Material } from "../../render/materials/material";
import { StandardMaterial } from "../../render/materials/standardMaterial";
import { MaterialLoaderMainOpacityEmissiveFresnel } from "./main_opacity_emissive_fresnel_material";

export class MaterialLoaderPiStandard {
    public static init() {
        LoadExtraMaterial.regist(
            "PiStandard",
            MaterialLoaderPiStandard.load
        );
    }
    public static load(loaders: LoaderRecord, info: IMainOpacityMaterial, indexNode, callback: (mat: Material, state: IRenderState) => void): Material {
            StandardMaterial.regist();
            let mat = new StandardMaterial("Mat", loaders.scene, undefined, loaders.scene.queryPassTag(info.renderQueue || 3000));

            MaterialLoaderMainOpacityEmissiveFresnel._loadProperty(loaders, mat, info, indexNode, callback);

            return mat;
    }
}