import * as GLTF2 from "./glTF2Interface";
import { UriLoader } from "./uri";
import { LoaderRecord } from "./base";

export class BufferLoader {
    public static _loadBufferAsync(loaders: LoaderRecord, index: number): Promise<Uint8Array> {
        let buffer = loaders.gltf.buffers[index];
        let loader = loaders.bufferLoaders.get(index);
        if (!loader) {
            loader = UriLoader.loadUriAsync(loaders, buffer, buffer.uri);
            loaders.bufferLoaders.set(index, loader);
        }

        return loader;
    }
}