import { LoaderRecord } from "./base";
import { BufferLoader } from "./buffer";

export class BufferViewLoader {
    public static loadAsync(loaders: LoaderRecord, index: number): Promise<Uint8Array> {
        let bufferView = loaders.gltf.bufferViews[index];
        let loader = loaders.bufferViewLoaders.get(index);
        if (!loader) {
            loader = BufferLoader._loadBufferAsync(loaders, bufferView.buffer).then((data) => {
                return new Uint8Array(data.buffer, (data.byteOffset + bufferView.byteOffset || 0), bufferView.byteLength);
            });
            loaders.bufferViewLoaders.set(index, loader);
        }
        return loader;
    }
}