import { IDisposable } from "./base";
import { EntityID } from "./entity";
import { Observable } from "./observable";

export interface IAnimationAttach {
    animationGroupMap: Map<EntityID, IAnimationGroup>;
}

export enum EAnimationEventTag {
    START    = 0b0000_0001,
    END      = 0b0000_0010,
    LOOP     = 0b0000_0100,
    FRAME    = 0b0000_1000,
}

export interface ITargetAnimationUniform {
    uniformTarget: EntityID,
    uniformProperty: string,
    group: EntityID,
    curve: number,
}

export interface ITargetAnimationAttribute {
    attributeTarget: EntityID,
    attributeProperty: string,
    group: EntityID,
    curve: number,
}

export interface ITargetAnimationProperty {
    target: EntityID,
    property: number,
    group: EntityID,
    curve: number,
}
export type ITargetAnimation = ITargetAnimationProperty | ITargetAnimationAttribute | ITargetAnimationUniform;


export interface IAnimationEventData {
    group: EntityID;
    target: EntityID;
    tag: EAnimationEventTag;
    data: number;
}

export interface IAnimationGroup extends IDisposable {
    // _onStart(data: IAnimationEventDataStart): any;
    // _onEnd(data: IAnimationEventDataEnd): any;
    // _onLoop(data: IAnimationEventDataLoop): any;
    // _onFrame(data: IAnimationEventDataFrame): any;
    goto(amount: number): IAnimationGroup;
}

export type IOfflineAnimationCfg = [string[], [number, string, number, number, number, number, number, number, number, number, number, any[]?][][], number[]];