import { IAbstractMesh, IBoundingBox } from "./abstractmesh";
import { Constants } from "./constants";
import { IGeometryLink } from "./geometry";
import { IInstanceSource } from "./instancedmesh";
import { IColor3 } from "./math";

export interface IMeshRenderQueue {
    renderingGroupId: number;
    alphaIndex: number;
}

export interface IMeshMaterialProperty {
    color: IColor3;
    alpha: number;
}

export interface IMeshMaterial {
    material: any;
}

export interface IMesh extends IMeshRenderQueue, IAbstractMesh, IGeometryLink, IInstanceSource {
    boundingBox: IBoundingBox;
    renderAlignment: Constants.RenderAlignment;
    receiveShadows: boolean;
    depthTest: Constants.CompareFunction;
    depthWrite: boolean;
    alphaMode: number;
    cullMode: Constants.CullMode;
    stencilTest: boolean;
    frontFace: Constants.FrontFace;
    doNotSyncBoundingInfo: boolean;
    indexStart: number;
    indexCount: number;
    vertexStart: number;
    vertexCount: number;
    applyBlend(): void;
    dispose(doNotRecurse?: boolean,disposeMaterialAndTextures?: boolean): void;
}