import { Constants } from "./constants";

export type Mat4Arr = [number, number, number, number, number, number, number, number, number, number, number, number, number, number, number, number];
export type Vec4Arr = [number, number, number, number, boolean];
export type Vec3Arr = [number, number, number, boolean];
export type Vec2Arr = [number, number, boolean];
export interface INodeMaterialTextureInfo {
    url: string,
    filterable: boolean,
    stage: Constants.ShaderStage,
    default: Constants.DefaultTexture,
    dimension: Constants.TextureViewDimension,
}
export interface INodeMaterialBlock {
    readonly key: string;
    readonly bind_defines: Constants.BindingState[];
    readonly depends: string[];
    readonly vs_define: string;
    readonly fs_define: string;
    readonly mat4: Map<string, Mat4Arr>;
    readonly vec4: Map<string, Vec4Arr>;
    readonly vec3: Map<string, Vec3Arr>;
    readonly vec2: Map<string, Vec2Arr>;
    readonly float: Map<string, [number, boolean]>;
    readonly uint: Map<string, [number, boolean]>;
    readonly texture: Map<string, INodeMaterialTextureInfo>;
}
export interface INodeMaterialBlockManager {
    regist(block: INodeMaterialBlock): void;
}