import { IMatrix, IVector3 } from "./math";
import { IAbstractMesh } from "./abstractmesh";
import { IDisposable } from "./base";
import { IEntity } from "./entity";
import { ITransformNode } from "./transform";

export interface IBone extends ITransformNode {
    setBindPose(matrix: IMatrix): void;
    // setAxisAngle(axis: IVector3, angle: number, space?: Space, mesh?: IAbstractMesh): void;
}

export interface ISkeleton extends IEntity, IDisposable {
    bones: IBone[];
    getPoseMatrix(): IMatrix;
    overrideMesh: IAbstractMesh;
}