
import * as BABYLON from "../render/index";

export interface IPIMaterialStripesVirtual {
    /**
     * 材质类型
     */
    type: string;

    /**
     * 共用材质的ID
     */
    instanceID?: string;

    alphaMode: number;
    needAlphaBlend?: 1;
    zWrite?: 1;

    alpha: number;
    cull: string;

    color0?: [number, number, number, number];
    color1?: [number, number, number, number];
}

export class StripesVirtualMaterial extends BABYLON.ShaderMaterial {
    // public static readonly _Name = "StripesVirtual";
    // public static readonly _StripesDirectional = "_StripesDirectional";
    // public static readonly _StripesColor0 = "_StripesColor0";
    // public static readonly _StripesColor1 = "_StripesColor1";
    // public static readonly _StripesInfo = "_StripesInfo";
    // private _stripesDirection: BABYLON.Vector3 = new BABYLON.Vector3(1, 1, 1);
    // private _stripesInfo: BABYLON.Vector4 = new BABYLON.Vector4(100, -1, 0, 1.0);
    // private _stripesColor0: BABYLON.Color4 = new BABYLON.Color4(0, 255 / 255, 39 / 255, 48 / 255);
    // private _stripesColor1: BABYLON.Color4 = new BABYLON.Color4(10 / 255, 255 / 255, 0, 92 / 255);
    // public get stripesDirection() {
    //     return this._stripesDirection;
    // }
    // public set stripesDirection(value: BABYLON.Vector3) {
    //     this._stripesDirection = value;
    //     this.setVector3(StripesVirtualMaterial._StripesDirectional, this._stripesDirection);
    // }
    // public get stripesColor0() {
    //     return this._stripesColor0;
    // }
    // public set stripesColor0(value: BABYLON.Color4) {
    //     this._stripesColor0 = value;
    //     this.setColor4(StripesVirtualMaterial._StripesColor0, this._stripesColor0);
    // }
    // public get stripesColor1() {
    //     return this._stripesColor1;
    // }
    // public set stripesColor1(value: BABYLON.Color4) {
    //     this._stripesColor1 = value;
    //     this.setColor4(StripesVirtualMaterial._StripesColor1, this._stripesColor1);
    // }
    // public get stripesStep() {
    //     return this._stripesInfo.x;
    // }
    // public set stripesStep(value: number) {
    //     this._stripesInfo.x = value;
    // }
    // public get stripesSpeed() {
    //     return this._stripesInfo.y;
    // }
    // public set stripesSpeed(value: number) {
    //     this._stripesInfo.y = value;
    // }
    // public get stripesFadeStart() {
    //     return this._stripesInfo.z;
    // }
    // public set stripesFadeStart(value: number) {
    //     this._stripesInfo.z = value;
    // }
    // public get stripesFadeEnd() {
    //     return this._stripesInfo.w;
    // }
    // public set stripesFadeEnd(value: number) {
    //     this._stripesInfo.w = value;
    // }
    // private _time: number = Date.now();
    // constructor(babylonScene: any, materialName: string, color1?: BABYLON.Color4, color2?: BABYLON.Color4) {
    //     super(
    //         materialName,
    //         babylonScene,
    //         `${StripesVirtualMaterial._Name}`,
    //         {
    //             attributes: ["position"],
    //             uniforms: ["worldViewProjection", "world", "time", StripesVirtualMaterial._StripesDirectional, StripesVirtualMaterial._StripesColor0, StripesVirtualMaterial._StripesColor1, StripesVirtualMaterial._StripesInfo],
    //             needAlphaBlending: true
    //         }
    //     );

    //     color1 && (this.stripesColor0 = color1);
    //     color2 && (this.stripesColor1 = color2);

    //     this.setVector3(StripesVirtualMaterial._StripesDirectional, this._stripesDirection);
    //     this.setColor4(StripesVirtualMaterial._StripesColor0, this._stripesColor0);
    //     this.setColor4(StripesVirtualMaterial._StripesColor1, this._stripesColor1);
    //     this.setVector4(StripesVirtualMaterial._StripesInfo, this._stripesInfo);
    // }

    // bind(world: BABYLON.Matrix, mesh?: BABYLON.Mesh, effectOverride?: BABYLON.Effect): void {
    //     this.setFloat('time', (Date.now() - this._time) / 1000);
    //     super.bind(world, mesh, effectOverride);
    // }
}

export function registStripesVirtualMaterialFactory() {
// //laserEffect
// BABYLON.Effect.ShadersStore[`${StripesVirtualMaterial._Name}VertexShader`] = `
//     precision highp float;

//     attribute vec3 position;

//     uniform mat4 worldViewProjection;
//     uniform mat4 world;

//     varying vec3 vPosition;

//     void main(void) {
//         vec3 positionUpdated = position;

//         vPosition = (world*vec4(positionUpdated, 1.0)).xyz;

//         gl_Position = worldViewProjection*vec4(positionUpdated, 1.0);
//     }
// `;

// BABYLON.Effect.ShadersStore[`${StripesVirtualMaterial._Name}FragmentShader`] =
//     `
//     precision highp float;

//     uniform vec3 ${StripesVirtualMaterial._StripesDirectional};
//     uniform vec4 ${StripesVirtualMaterial._StripesColor0};
//     uniform vec4 ${StripesVirtualMaterial._StripesColor1};
//     uniform vec4 ${StripesVirtualMaterial._StripesInfo};
//     uniform float time;

//     varying vec3 vPosition;

//     void main(void) {

//         float temp          = dot(vPosition, ${StripesVirtualMaterial._StripesDirectional});
//         temp                = fract(temp / ${StripesVirtualMaterial._StripesInfo}.x + ${StripesVirtualMaterial._StripesInfo}.y * time);
//         temp                = abs((temp - 0.5) * 2.);
//         temp                = smoothstep(${StripesVirtualMaterial._StripesInfo}.z, ${StripesVirtualMaterial._StripesInfo}.w, temp);

//         vec4 result = mix(${StripesVirtualMaterial._StripesColor0}, ${StripesVirtualMaterial._StripesColor1}, temp);

//         gl_FragColor = result;
//     }
// `;

// function create(context: string, babylonScene: any, materialName: string, index: number, materialInfo: IPIMaterialStripesVirtual, babylonDrawMode: number): any {
//     let mat = new StripesVirtualMaterial(babylonScene, materialName);

//     if (materialInfo.color0) {
//         mat.stripesColor0.copyFromFloats(
//             materialInfo.color0[0], materialInfo.color0[1], materialInfo.color0[2], materialInfo.color0[3]
//         );
//     }
//     if (materialInfo.color1) {
//         mat.stripesColor1.copyFromFloats(
//             materialInfo.color1[0], materialInfo.color1[1], materialInfo.color1[2], materialInfo.color1[3]
//         );
//     }

//     return mat;
// }

// function loadAsync(context: string, materialInfo: IPIMaterialStripesVirtual, mat: BABYLON.StandardMaterial, _loader: any): Promise<void> {
//     return Promise.resolve();
// }

// BABYLON.GLTF2.Loader.Extensions.PI_material.regist(
//     "StripesVirtual",
//     create,
//     loadAsync
// );

}