
import { IParticle } from "../particle_base";
import { Color4Interpolate, IParticleModifier, ScalingInterpolate, TempColor4A, TempVector3A, TranslationInterpolate } from "./base";

export class ColorOverLifetime extends Color4Interpolate implements IParticleModifier {
    modify(particle: IParticle, amount: number, deltaSeconds: number) {
        let localResult = TempColor4A;

        this.compute(amount, localResult, particle.colorOverLifetimeAmount);

        particle.color.multiplyToRef(localResult, particle.color);
    }
}