import { FloatInterpolation } from "../interpolation";
import { IParticle } from "../particle_base";
import { IParticleModifier } from "./base";

export class CustomDataForUV implements IParticleModifier {
    public uScale: FloatInterpolation = new FloatInterpolation();
    public vScale: FloatInterpolation = new FloatInterpolation();
    public uOffset: FloatInterpolation = new FloatInterpolation();
    public vOffset: FloatInterpolation = new FloatInterpolation();
    constructor() {
        this.uScale.constant0 = 1;
        this.vScale.constant0 = 1;
    }
    modify(particle: IParticle, amount: number, deltaSeconds: number): void {
        particle.uv[0] = 1.0 / this.uScale.interpolate(amount, particle.baseRandom[0]);
        particle.uv[1] = 1.0 / this.vScale.interpolate(amount, particle.baseRandom[1]);
        particle.uv[2] = this.uOffset.interpolate(amount, particle.baseRandom[2]);
        particle.uv[3] = this.vOffset.interpolate(amount, particle.baseRandom[3]);
    }
}