
import * as BABYLON from "../../render/index";
// import * as BABYLON from "../../pi_babylon/render3d/babylon";
import { IParticle } from "../particle_base";
import { IParticleModifier, TempVector3A } from "./base";
import { FloatInterpolation } from "../interpolation";

export class Gravity implements IParticleModifier {
    public static defualtForce = new BABYLON.Vector3(0, -9.8, 0);
    constructor(
        public interpolation: FloatInterpolation
    ) {
        //
    }
    modify(particle: IParticle, amount: number, deltaSeconds: number) {
        let factor = this.interpolation.interpolate(amount, particle.baseRandom[0]);

        let localForce = TempVector3A;
        Gravity.defualtForce.scaleToRef(factor, localForce);
        BABYLON.Vector3.TransformCoordinatesFromFloatsToRef(localForce.x, localForce.y, localForce.z, particle.startWorldMatrixInvert, localForce);

        localForce.scaleInPlace(deltaSeconds);

        particle.direction.addInPlace(localForce);
    }
}