
import { IParticle } from "../particle_base";
import { IParticleModifier, TempVector3A } from "./base";
import { FloatInterpolation } from "../interpolation";

export class Noise implements IParticleModifier {
    positionAmount: number = 1;
    rotationAmount: number = 0;
    sizenAmount: number = 0;
    frequency = 1;
    lastRecord = -1;
    randoms = [0, 0, 0, 0, 0, 0, 0, 0, 0];
    modify(particle: IParticle, amount: number, deltaSeconds: number) {
        deltaSeconds = 1;
        let tt = particle.age / particle.lifetime * 4;
        let t = Math.floor(tt);
        let s = Math.sin((tt - t) * Math.PI * 2);
        if (this.lastRecord != t) {
            this.lastRecord = t;
            this.randoms[0] = (Math.random() - 0.5) * this.positionAmount * deltaSeconds;
            this.randoms[1] = (Math.random() - 0.5) * this.positionAmount * deltaSeconds;
            this.randoms[2] = (Math.random() - 0.5) * this.positionAmount * deltaSeconds;

            this.randoms[3] = (Math.random() - 0.5) * this.rotationAmount * deltaSeconds;
            this.randoms[4] = (Math.random() - 0.5) * this.rotationAmount * deltaSeconds;
            this.randoms[5] = (Math.random() - 0.5) * this.rotationAmount * deltaSeconds;

            this.randoms[6] = (Math.random() - 0.5) * this.sizenAmount * deltaSeconds;
            this.randoms[7] = (Math.random() - 0.5) * this.sizenAmount * deltaSeconds;
            this.randoms[8] = (Math.random() - 0.5) * this.sizenAmount * deltaSeconds;
        }
        particle.position.addInPlaceFromFloats(this.randoms[0] * s, this.randoms[1] * s, this.randoms[2] * s);

        particle.rotation.addInPlaceFromFloats(this.randoms[3] * s, this.randoms[4] * s, this.randoms[5] * s);

        particle.scaling.addInPlaceFromFloats(this.randoms[6] * s, this.randoms[7] * s, this.randoms[8] * s);
    }
}