
import { IParticle } from "../particle_base";
import { IParticleModifier, RotationInterpolate, TempVector3A, TranslationInterpolate } from "./base";

export class RotationBySpeed extends RotationInterpolate implements IParticleModifier {
    private _rangeX: number = 0;
    public set rangeX(value: number) {
        this._rangeX = value;
        this._rangeSize = this._rangeY - this._rangeX;
    }
    public get rangeX() {
        return this._rangeX;
    }
    private _rangeY: number = 1;
    public set rangeY(value: number) {
        this._rangeY = value;
        this._rangeSize = this._rangeY - this._rangeX;
    }
    public get rangeY() {
        return this._rangeY;
    }
    public _rangeSize: number = 1;
    modify(particle: IParticle, amount: number, deltaSeconds: number) {
        let localResult = TempVector3A;

        amount = Math.min(1, Math.max(0, (particle.directionLength - this._rangeX) / this._rangeSize));
        this.compute(amount, particle.baseRandom, localResult);

        localResult.scaleInPlace(deltaSeconds);

        particle.rotation.addInPlace(localResult);
    }
}