
import { IParticle } from "../particle_base";
import { IParticleModifier, ScalingInterpolate, TempVector3A, TranslationInterpolate } from "./base";

export class SizeOverLifetime extends ScalingInterpolate implements IParticleModifier {
    modify(particle: IParticle, amount: number, deltaSeconds: number) {
        let localResult = TempVector3A;

        this.compute(amount, particle.baseRandom, localResult);

        particle.scaling.multiplyToRef(localResult, particle.scaling);
    }
}