/**
 * 一个关键点 增加 两个绘制点 两个UV点 2个三角形
 */
export class TrailGeometryModifier {
    public static triangleCount = 2;
    public static modifyPosition(ax: number, ay: number, az: number, extendX: number, extendY: number, extendZ: number, positiondata: number[], pointIndex: number) {
        let offset = pointIndex * 2 * 3; // 2 个 vec3
        positiondata[offset + 0] = ax - extendX;
        positiondata[offset + 1] = ay - extendY;
        positiondata[offset + 2] = az - extendZ;

        positiondata[offset + 3] = ax + extendX;
        positiondata[offset + 4] = ay + extendY;
        positiondata[offset + 5] = az + extendZ;
    }
    public static modifyUV(au: number, uvdata: number[], pointIndex: number) {
        let offset = pointIndex * 2 * 2;
        uvdata[offset + 0] = au;
        uvdata[offset + 1] = 0;

        uvdata[offset + 2] = au;
        uvdata[offset + 3] = 1;
    }
    public static modifyColor(r: number, g: number, b: number, a: number, colordata: number[], pointIndex: number) {
        let offset = pointIndex * 2 * 4;
        colordata[offset + 0] = r;
        colordata[offset + 1] = g;
        colordata[offset + 2] = b;
        colordata[offset + 3] = a;

        colordata[offset + 4] = r;
        colordata[offset + 5] = g;
        colordata[offset + 6] = b;
        colordata[offset + 7] = a;
    }
    public static modifyIndices(indicesdata: number[], pointIndex: number) {
        let offset = (pointIndex - 1) * 2 * 3; // 2 个 三角形
        let indicesOffset = (pointIndex - 1) * 2;

        indicesdata[offset + 0] = indicesOffset + 0;
        indicesdata[offset + 1] = indicesOffset + 1;
        indicesdata[offset + 2] = indicesOffset + 2;

        indicesdata[offset + 3] = indicesOffset + 1;
        indicesdata[offset + 4] = indicesOffset + 3;
        indicesdata[offset + 5] = indicesOffset + 2;
    }
}