import * as BABYLON from "../render/index";
// import * as BABYLON from "../pi_babylon/render3d/babylon";
import { IParticle } from "./particle_base";

export class Particle implements IParticle {
    startWorldMatrix: BABYLON.Matrix = BABYLON.Matrix.Identity();
    startWorldMatrixInvert: BABYLON.Matrix = BABYLON.Matrix.Identity();
    emitWorldMatrix: BABYLON.Matrix = BABYLON.Matrix.Identity();
    startScaling: BABYLON.Vector3 = BABYLON.Vector3.One();
    startColor: BABYLON.Color4 = new BABYLON.Color4(1, 1, 1, 1);
    emitRotation: BABYLON.Vector3 = BABYLON.Vector3.Zero();
    position: BABYLON.Vector3 = BABYLON.Vector3.Zero();
    rotation: BABYLON.Vector3 = BABYLON.Vector3.Zero();
    scaling: BABYLON.Vector3 = BABYLON.Vector3.One();
    velocity: BABYLON.Vector3 = BABYLON.Vector3.Zero();
    direction: BABYLON.Vector3 = BABYLON.Vector3.Zero();
    readldirection: BABYLON.Vector3 = BABYLON.Vector3.Zero();
    directionLength: number = 0;
    color: BABYLON.Color4 = new BABYLON.Color4(1, 1, 1, 1);
    textureStartFrame: number = 0;
    textureRow: number = 0;
    age: number = Number.MAX_SAFE_INTEGER;
    lifetime: number = 1000;
    trialLifetime: number = 0;
    trialWidth: number = 1;
    uv: [number, number, number, number] = [1, 1, 0, 0];
    lifeRecordList: number[] = [];
    globalPositionList: BABYLON.Vector3[] = [];
    localPositionList: BABYLON.Vector3[] = [];
    globalRecordList: [number, number, number, number][] = [];
    localRecordList: [number, number, number, number][] = [];
    colorOverLifetimeAmount: number = Math.random();
    baseRandom: [number, number, number, number];
    reset(): void {
        this.age = Number.MAX_SAFE_INTEGER;
        this.lifetime = 1000;
        this.trialLifetime = 0;
        this.startWorldMatrix.reset();
        this.startWorldMatrixInvert.reset();
        this.emitWorldMatrix.reset();
        this.startScaling.copyFromFloats(1, 1, 1);
        this.startColor.copyFromFloats(1, 1, 1, 1);
        this.emitRotation.copyFromFloats(0, 0, 0);
        this.position.copyFromFloats(0, 0, 0);
        this.rotation.copyFromFloats(0, 0, 0);
        this.scaling.copyFromFloats(1, 1, 1);
        this.velocity.copyFromFloats(0, 0, 0);
        this.direction.copyFromFloats(0, 0, 0);
        this.readldirection.copyFromFloats(0, 0, 0);
        this.directionLength = 0;
        this.color.copyFromFloats(1, 1, 1, 1);
        this.baseRandom = [Math.random(), Math.random(), Math.random(), Math.random()];
        this.uv[0] = 1, this.uv[1] = 1, this.uv[2] = 0, this.uv[3] = 0;
        this.globalPositionList.length = 0;
        this.localPositionList.length = 0;
        this.lifeRecordList.length = 0;
    }
}