import * as BABYLON from "../render/index";
// import * as BABYLON from "../pi_babylon/render3d/babylon";
import { Particle } from "./particle";

export class Pool {
    public static particleList: Particle[] = [];
    public static vector3List: BABYLON.Vector3[] = [];

    public static createParticle() {
        let value = Pool.particleList.pop();
        if (!value) {
            value = new Particle();
        }

        return value;
    }

    public static recycleParticle(value: Particle) {
        value.reset();
        Pool.particleList.push(value);
    }

    public static createVector3() {
        let result = Pool.vector3List.pop();
        if (!result) {
            result = new BABYLON.Vector3();
        }

        return result;
    }

    public static recycleVector3(value: BABYLON.Vector3) {
        Pool.vector3List.push(value);
    }
}