import { IPostprocessParamType } from "./base";

export const KeyBloomCombine = "BloomCombine";
export interface IBloomCombine {
    etype: typeof KeyBloomCombine;
    /**
     * Bloom 强度
     */
    intensity: number;
}

export const KeyBloomThreshold = "BloomThreshold";
export interface IBloomThreshold {
    etype: typeof KeyBloomThreshold;
    thresholdKnee: number;
    threshold: number;
}

export const KeyBloom = "Bloom";
export interface IBloom extends IPostprocessParamType {
    etype: typeof KeyBloom;
    thresholdKnee: number;
    threshold: number;
    /**
     * Bloom 强度
     */
    intensity: number;
    /**
     * 模糊半径
     */
    blurRadius: number;
    /**
     * 效果迭代次数
     */
    useBlurIteration: number;
}