import { IPostprocessParamType } from "./base";

export const KeyColorEffect = "ColorEffect";
export interface IColorEffect extends IPostprocessParamType {
    etype: typeof KeyColorEffect;
    /**
     * 色相 - 对应Photoshop的[-180, 180]
     */
    hue: number;
    /**
     * 饱和度 对应Photoshop的[-100, 100]
     */
    saturate: number;
    /**
     * 明度 对应Photoshop的[-100, 100]
     */
    brightness: number;

    /**
     * 色彩平衡 - R 对应Photoshop的[-100, 100]
     */
    colorBalanceR: number;
    /**
     * 色彩平衡 - G 对应Photoshop的[-100, 100]
     */
    colorBalanceG: number;
    /**
     * 色彩平衡 - B 对应Photoshop的[-100, 100]
     */
    colorBalanceB: number;

    /**
     * 色阶 - 输入阈值的区间左边界 - 0-255
     */
    colorScaleRInShadow: number;
    /**
     * 色阶 - 中间调 - 9.99~0.1
     */
    colorScaleRInMid: number;
    /**
     * 色阶 - 输入阈值的区间右边界 - 0-255
     */
    colorScaleRInHighlight: number;
    /**
     * 色阶 - 输出阈值区间左边界 - 0-255
     */
    colorScaleROutShadow: number;
    /**
     * 色阶 - 输出阈值区间右边界 - 0-255
     */
    colorScaleROutHighlight: number;
}