import { IPostprocessParamType } from "./base";

export const KeyRadiusWave = "RadiusWave";
export interface IRadiusWave extends IPostprocessParamType {
    etype: typeof KeyRadiusWave;
    /**
     *  是否处理为圆形
     */
    asCircle: boolean;
    /**
     * 模糊半径 - 像素值
     */
    blurRadius: number;
    /**
     * 波纹径向起点 0-2
     */
    waveStartRadius: number;
    /**
     * 波纹径向终点 0-2
     */
    waveEndRadius: number;
    /**
     * 波纹数量
     */
    waveCounter: number;
    /**
     * 波纹高度 - 扭曲值域
     */
    waveWeight: number;
}
