import { IPostprocessParamType } from "./base";

export const KeyVignette = "Vignette";
/**
 * 该效果坐标系 以屏幕中心为原点, 在屏幕径向边缘产生效果
 */
export interface IVignette extends IPostprocessParamType {
    etype: typeof KeyVignette;
    /**
     * 效果开始的位置
     */
    begin: number;
    /**
     * 效果达到最强时的位置
     */
    end: number;
    /**
     * 效果由开始到最强的过渡控制
     */
    scale: number;
    /**
     * 效果颜色
     */
    vignetteColor: [number, number, number];
}
