
import { FrameCurve, FrameCurveV1Easing, FrameCurveV1Frames, FrameCurveV1FramesStep, FrameCurveV1GLTFCubicSpline, FrameCurveV1PIGLTFCubicSpline } from "./base";
import { Constants, ITargetAnimationUniform } from "../../../interface/index";
import { p3d } from "../../types";

const KEY = Constants.U_OPACITY;

export class FrameCurveAlpha extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.Alpha;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveAlphaStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.Alpha;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveAlphaCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.Alpha;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveAlphaPICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.Alpha;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveAlphaEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.Alpha;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}