
import { FrameCurve, FrameCurveV1Easing, FrameCurveV1Frames, FrameCurveV1FramesStep, FrameCurveV1GLTFCubicSpline, FrameCurveV1PIGLTFCubicSpline } from "./base";
import { Constants, ITargetAnimationUniform } from "../../../interface/index";
import { p3d } from "../../types";

const KEY = Constants.U_CUTOFF;

export class FrameCurveAlphaCutoff extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.AlphaCutoff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveAlphaCutoffStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.AlphaCutoff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveAlphaCutoffCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.AlphaCutoff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveAlphaCutoffPICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.AlphaCutoff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveAlphaCutoffEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.AlphaCutoff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}