
import { FrameCurve, FrameCurveV3Easing, FrameCurveV3Frames, FrameCurveV3FramesStep, FrameCurveV3GLTFCubicSpline, FrameCurveV3PIGLTFCubicSpline } from "./base";
import { Constants, ITargetAnimationUniform } from "../../../interface/index";
import { p3d } from "../../types";

const KEY = Constants.U_MAIN_COLOR;

export class FrameCurveMainColor extends FrameCurveV3Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainColor;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveMainColorStep extends FrameCurveV3FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainColor;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveMainColorCubicSpline extends FrameCurveV3GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainColor;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveMainColorPICubicSpline extends FrameCurveV3PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainColor;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveMainColorEasing extends FrameCurveV3Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainColor;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}