
import { FrameCurve, FrameCurveV1Easing, FrameCurveV1Frames, FrameCurveV1FramesStep, FrameCurveV1GLTFCubicSpline, FrameCurveV1PIGLTFCubicSpline, FrameCurveV4Easing, FrameCurveV4Frames, FrameCurveV4FramesStep, FrameCurveV4GLTFCubicSpline, FrameCurveV4PIGLTFCubicSpline } from "./base";
import { UniformMainTexture } from "../../materials/node_material/mainTextureBlock";
import { Constants, ITargetAnimationUniform } from "../../../interface/index";
import { p3d } from "../../types";

const KEY = Constants.U_MAIN_TILLOFF;

export class FrameCurveMainTexUScale extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_USCALE, }
    }
}
export class FrameCurveMainTexUScaleStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_USCALE, }
    }
}
export class FrameCurveMainTexUScaleCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_USCALE, }
    }
}
export class FrameCurveMainTexUScalePICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_USCALE, }
    }
}
export class FrameCurveMainTexUScaleEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_USCALE, }
    }
}

export class FrameCurveMainTexVScale extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VSCALE, }
    }
}
export class FrameCurveMainTexVScaleStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VSCALE, }
    }
}
export class FrameCurveMainTexVScaleCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VSCALE, }
    }
}
export class FrameCurveMainTexVScalePICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VSCALE, }
    }
}
export class FrameCurveMainTexVScaleEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VSCALE, }
    }
}

export class FrameCurveMainTexUOffset extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveMainTexUOffsetStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveMainTexUOffsetCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveMainTexUOffsetPICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveMainTexUOffsetEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_UOFFSET, }
    }
}

export class FrameCurveMainTexVOffset extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveMainTexVOffsetStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveMainTexVOffsetCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveMainTexVOffsetPICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveMainTexVOffsetEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMainTexture.KEY_VOFFSET, }
    }
}

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
export class FrameCurveMainTexTilloff extends FrameCurveV4Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveMainTexTilloffStep extends FrameCurveV4FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveMainTexTilloffCubicSpline extends FrameCurveV4GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveMainTexTilloffPICubicSpline extends FrameCurveV4PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveMainTexTilloffEasing extends FrameCurveV4Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MainTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}