
import { FrameCurveV1Easing, FrameCurveV1Frames, FrameCurveV1FramesStep, FrameCurveV1GLTFCubicSpline, FrameCurveV1PIGLTFCubicSpline } from "./base";
import { UniformMaskTexture } from "../../materials/node_material/maskTextureBlock";
import { Constants, ITargetAnimationUniform } from "../../../interface/index";
import { p3d } from "../../types";

const KEY = Constants.U_MASK_TILLOFF;

export class FrameCurveMaskTexUScale extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_USCALE, }
    }
}
export class FrameCurveMaskTexUScaleStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_USCALE, }
    }
}
export class FrameCurveMaskTexUScaleCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_USCALE, }
    }
}
export class FrameCurveMaskTexUScalePICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_USCALE, }
    }
}
export class FrameCurveMaskTexUScaleEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_USCALE, }
    }
}

export class FrameCurveMaskTexVScale extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VSCALE, }
    }
}
export class FrameCurveMaskTexVScaleStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VSCALE, }
    }
}
export class FrameCurveMaskTexVScaleCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VSCALE, }
    }
}
export class FrameCurveMaskTexVScalePICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VSCALE, }
    }
}
export class FrameCurveMaskTexVScaleEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VSCALE, }
    }
}

export class FrameCurveMaskTexUOffset extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveMaskTexUOffsetStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveMaskTexUOffsetCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveMaskTexUOffsetPICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveMaskTexUOffsetEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_UOFFSET, }
    }
}

export class FrameCurveMaskTexVOffset extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveMaskTexVOffsetStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveMaskTexVOffsetCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveMaskTexVOffsetPICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveMaskTexVOffsetEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.MaskTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformMaskTexture.KEY_VOFFSET, }
    }
}
