
import { FrameCurveV1Easing, FrameCurveV1Frames, FrameCurveV1FramesStep, FrameCurveV1GLTFCubicSpline, FrameCurveV1PIGLTFCubicSpline, FrameCurveV4Easing, FrameCurveV4Frames, FrameCurveV4FramesStep, FrameCurveV4GLTFCubicSpline, FrameCurveV4PIGLTFCubicSpline } from "./base";
import { UniformOpacityTexture } from "../../materials/node_material/opacityBlock";
import { Constants, ITargetAnimationUniform } from "../../../interface/index";
import { p3d } from "../../types";

const KEY = Constants.U_OPACITY_TILLOFF;

export class FrameCurveOpacityTexUScale extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_USCALE, }
    }
}
export class FrameCurveOpacityTexUScaleStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_USCALE, }
    }
}
export class FrameCurveOpacityTexUScaleCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_USCALE, }
    }
}
export class FrameCurveOpacityTexUScalePICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_USCALE, }
    }
}
export class FrameCurveOpacityTexUScaleEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_USCALE, }
    }
}

export class FrameCurveOpacityTexVScale extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VSCALE, }
    }
}
export class FrameCurveOpacityTexVScaleStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VSCALE, }
    }
}
export class FrameCurveOpacityTexVScaleCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VSCALE, }
    }
}
export class FrameCurveOpacityTexVScalePICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VSCALE, }
    }
}
export class FrameCurveOpacityTexVScaleEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVScale;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VSCALE, }
    }
}

export class FrameCurveOpacityTexUOffset extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveOpacityTexUOffsetStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveOpacityTexUOffsetCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveOpacityTexUOffsetPICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_UOFFSET, }
    }
}
export class FrameCurveOpacityTexUOffsetEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexUOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_UOFFSET, }
    }
}

export class FrameCurveOpacityTexVOffset extends FrameCurveV1Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveOpacityTexVOffsetStep extends FrameCurveV1FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveOpacityTexVOffsetCubicSpline extends FrameCurveV1GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveOpacityTexVOffsetPICubicSpline extends FrameCurveV1PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VOFFSET, }
    }
}
export class FrameCurveOpacityTexVOffsetEasing extends FrameCurveV1Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexVOffset;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: UniformOpacityTexture.KEY_VOFFSET, }
    }
}

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
export class FrameCurveOpacityTexTilloff extends FrameCurveV4Frames  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveOpacityTexTilloffStep extends FrameCurveV4FramesStep  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveOpacityTexTilloffCubicSpline extends FrameCurveV4GLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveOpacityTexTilloffPICubicSpline extends FrameCurveV4PIGLTFCubicSpline  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}
export class FrameCurveOpacityTexTilloffEasing extends FrameCurveV4Easing  {
    protected _property: p3d.EAnimePropertyID = p3d.EAnimePropertyID.OpacityTexTilloff;
    public targetAnimation(group: number, target: number) {
        return <ITargetAnimationUniform>{ group, curve: this.id, uniformTarget: target, uniformProperty: KEY, }
    }
}