import { Collider } from './collider';
import { Vector3 } from '../../maths/math.vector';
import { ICollisionResponse, Nullable, Observer } from '../../interface/index';

/**
 * @hidden
 */
export class _MeshCollisionData<T extends ICollisionResponse> {
    public _checkCollisions = false;
    public _collisionMask = -1;
    public _collisionGroup = -1;
    public _surroundingMeshes: Nullable<T[]> = null;
    public _collider: Nullable<Collider> = null;
    public _oldPositionForCollisions = new Vector3(0, 0, 0);
    public _diffPositionForCollisions = new Vector3(0, 0, 0);
    public _onCollideObserver: Nullable<Observer<T>>;
    public _onCollisionPositionChangeObserver: Nullable<Observer<Vector3>>;
    public _collisionResponse = true;
}