import { BaseTexture } from "./baseTexture";
import { Engine } from "../../engines/engine";

export class DataTexture extends BaseTexture {
    private static CombineCounter: number = 1;
    protected readonly _uniqueId: number;
    protected readonly _uniqueKey: string;
    protected readonly _width: number;
    protected readonly _height: number;
    protected readonly _format: number;
    constructor(format: number, width: number, height: number) {
        super()
        this._uniqueId = DataTexture.CombineCounter++;
        this._uniqueKey = `Combine${this._uniqueId}`;
        this._width = width;
        this._height = height;
        this._format = format;
        Engine.CreateDataTexture(this._uniqueKey, width, height, format);
    }
    public update(data: Uint8Array, xoffset: number, yoffset: number, width: number, height: number) {
        Engine.UpdateDataTexture(this._uniqueKey, data, xoffset, yoffset, width, height);
    }
    dispose() {
        Engine.DeleteDataTexture(this._uniqueKey);
    }
}