import { Engine } from "../../engines/engine";
import { Constants } from "../../../interface/index";
import { p3d } from "../../types";
import { ExtensionTools } from "../../../base";

export class UniformEmissiveFresnel {
    public static KEY_LEFT: string = Constants.U_FRESNEL_LEFT
    public static KEY_RIGHT: string = Constants.U_FRESNEL_RIGHT
    public static KEY_PARAM: string = Constants.U_FRESNEL_PARAM
    public static left(mat: number, r: number, g: number, b: number) {
        p3d.p3d_material_uniform_vec4(Engine.commands(), mat, ExtensionTools.getAtom(UniformEmissiveFresnel.KEY_LEFT), r, g, b, 1.);
    }
    public static right(mat: number, r: number, g: number, b: number) {
        p3d.p3d_material_uniform_vec4(Engine.commands(), mat, ExtensionTools.getAtom(UniformEmissiveFresnel.KEY_RIGHT), r, g, b, 1.);
    }
    public static biasAndPower(mat: number, bias: number, power: number) {
        p3d.p3d_material_uniform_vec2(Engine.commands(), mat, ExtensionTools.getAtom(UniformEmissiveFresnel.KEY_PARAM), bias, power);
    }
}

export class UniformOpacityFresnel {
    public static KEY_LEFT: string = Constants.U_OPACITY_FRESNEL_LEFT
    public static KEY_RIGHT: string = Constants.U_OPACITY_FRESNEL_RIGHT
    public static KEY_PARAM: string = Constants.U_OPACITY_FRESNEL_PARAM
    public static left(mat: number, val: number) {
        p3d.p3d_material_uniform_float(Engine.commands(), mat, ExtensionTools.getAtom(UniformOpacityFresnel.KEY_LEFT), val);
    }
    public static right(mat: number, val: number) {
        p3d.p3d_material_uniform_float(Engine.commands(), mat, ExtensionTools.getAtom(UniformOpacityFresnel.KEY_RIGHT), val);
    }
    public static biasAndPower(mat: number, bias: number, power: number) {
        p3d.p3d_material_uniform_vec2(Engine.commands(), mat, ExtensionTools.getAtom(UniformOpacityFresnel.KEY_PARAM), bias, power);
    }
}