// import { BABYLON } from "../babylon";

// type InternalTexture = BABYLON.InternalTexture;
// type Nullable<T> = BABYLON.Nullable<T>;

// const Tools = BABYLON.Tools;
// const Scalar = BABYLON.Scalar;
// const Constants = BABYLON.Constants;

// export function initEnvironmentTextureTools() {

//     BABYLON.EnvironmentTextureTools.CreateImageDataArrayBufferViews = function(data: ArrayBufferView, info: BABYLON.EnvironmentTextureInfo): Array<Array<ArrayBufferView>> {
//         if (info.version !== 1) {
//             throw new Error(`Unsupported babylon environment map version "${info.version}"`);
//         }

//         const specularInfo = info.specular as BABYLON.EnvironmentTextureSpecularInfoV1;

//         // Double checks the enclosed info
//         let mipmapsCount = Scalar.Log2(info.width);
//         mipmapsCount = Math.round(mipmapsCount) + 1;
//         if (specularInfo.mipmaps.length !== 6 * mipmapsCount) {
//             throw new Error(`Unsupported specular mipmaps number "${specularInfo.mipmaps.length}"`);
//         }

//         const imageData = new Array<Array<ArrayBufferView>>(mipmapsCount);
//         for (let i = 0; i < mipmapsCount; i++) {
//             imageData[i] = new Array<ArrayBufferView>(6);
//             for (let face = 0; face < 6; face++) {
//                 const imageInfo = specularInfo.mipmaps[i * 6 + face];
//                 let start = data.byteOffset + specularInfo.specularDataPosition! + imageInfo.position;
//                 imageData[i][face] = new Uint8Array(data.buffer.slice(start, start + imageInfo.length));
//             }
//         }

//         return imageData;
//     };

//     BABYLON.EnvironmentTextureTools.UploadLevelsAsync = function (texture: InternalTexture, imageData: ArrayBufferView[][]): Promise<void> {
//         if (!Tools.IsExponentOfTwo(texture.width)) {
//             throw new Error("Texture size must be a power of two");
//         }

//         const mipmapsCount = Math.round(Scalar.Log2(texture.width)) + 1;

//         // Gets everything ready.
//         let engine = texture.getEngine() as BABYLON.Engine;
//         let expandTexture = false;
//         let generateNonLODTextures = false;
//         let rgbdPostProcess: Nullable<BABYLON.PostProcess> = null;
//         let cubeRtt: Nullable<InternalTexture> = null;
//         let lodTextures: Nullable<{ [lod: number]: BABYLON.BaseTexture }> = null;
//         let caps = engine.getCaps();

//         texture.format = Constants.TEXTUREFORMAT_RGBA;
//         texture.type = Constants.TEXTURETYPE_UNSIGNED_INT;
//         texture.generateMipMaps = true;
//         texture._cachedAnisotropicFilteringLevel = null;
//         engine.updateTextureSamplingMode(Constants.TEXTURE_TRILINEAR_SAMPLINGMODE, texture);

//         // Add extra process if texture lod is not supported
//         if (!caps.textureLOD) {
//             expandTexture = false;
//             generateNonLODTextures = true;
//             lodTextures = {};
//         }
//         // in webgl 1 there are no ways to either render or copy lod level information for float textures.
//         else if (engine.webGLVersion < 2) {
//             expandTexture = false;
//         }
//         // If half float available we can uncompress the texture
//         else if (caps.textureHalfFloatRender && caps.textureHalfFloatLinearFiltering) {
//             expandTexture = true;
//             texture.type = Constants.TEXTURETYPE_HALF_FLOAT;
//         }
//         // If full float available we can uncompress the texture
//         else if (caps.textureFloatRender && caps.textureFloatLinearFiltering) {
//             expandTexture = true;
//             texture.type = Constants.TEXTURETYPE_FLOAT;
//         }

//         // Expand the texture if possible
//         if (expandTexture) {
//             // Simply run through the decode PP
//             rgbdPostProcess = new BABYLON.PostProcess("rgbdDecode", "rgbdDecode", null, null, 1, null, Constants.TEXTURE_TRILINEAR_SAMPLINGMODE, engine, false, undefined, texture.type, undefined, null, false);

//             texture._isRGBD = false;
//             texture.invertY = false;
//             cubeRtt = engine.createRenderTargetCubeTexture(texture.width, {
//                 generateDepthBuffer: false,
//                 generateMipMaps: true,
//                 generateStencilBuffer: false,
//                 samplingMode: Constants.TEXTURE_TRILINEAR_SAMPLINGMODE,
//                 type: texture.type,
//                 format: Constants.TEXTUREFORMAT_RGBA
//             });
//         }
//         else {
//             texture._isRGBD = true;
//             texture.invertY = true;

//             // In case of missing support, applies the same patch than DDS files.
//             if (generateNonLODTextures) {
//                 let mipSlices = 3;
//                 let scale = texture._lodGenerationScale;
//                 let offset = texture._lodGenerationOffset;

//                 for (let i = 0; i < mipSlices; i++) {
//                     //compute LOD from even spacing in smoothness (matching shader calculation)
//                     let smoothness = i / (mipSlices - 1);
//                     let roughness = 1 - smoothness;

//                     let minLODIndex = offset; // roughness = 0
//                     let maxLODIndex = (mipmapsCount - 1) * scale + offset; // roughness = 1 (mipmaps start from 0)

//                     let lodIndex = minLODIndex + (maxLODIndex - minLODIndex) * roughness;
//                     let mipmapIndex = Math.round(Math.min(Math.max(lodIndex, 0), maxLODIndex));

//                     let glTextureFromLod = new BABYLON.InternalTexture(engine, BABYLON.InternalTextureSource.Temp);
//                     glTextureFromLod.isCube = true;
//                     glTextureFromLod.invertY = true;
//                     glTextureFromLod.generateMipMaps = false;
//                     engine.updateTextureSamplingMode(Constants.TEXTURE_LINEAR_LINEAR, glTextureFromLod);

//                     // Wrap in a base texture for easy binding.
//                     let lodTexture = new BABYLON.BaseTexture(null);
//                     lodTexture.isCube = true;
//                     lodTexture._texture = glTextureFromLod;
//                     lodTextures![mipmapIndex] = lodTexture;

//                     switch (i) {
//                         case 0:
//                             texture._lodTextureLow = lodTexture;
//                             break;
//                         case 1:
//                             texture._lodTextureMid = lodTexture;
//                             break;
//                         case 2:
//                             texture._lodTextureHigh = lodTexture;
//                             break;
//                     }
//                 }
//             }
//         }

//         let promises: Promise<void>[] = [];
//         // All mipmaps up to provided number of images
//         for (let i = 0; i < imageData.length; i++) {
//             // All faces
//             for (let face = 0; face < 6; face++) {
//                 // Constructs an image element from image data
//                 let bytes = imageData[i][face];
//                 let promise: Promise<void> = new Promise((resolve, reject) => {
//                     if (expandTexture) {
//                         let tempTexture = engine.createTexture(null, true, true, null, Constants.TEXTURE_NEAREST_SAMPLINGMODE, null,
//                             (message) => {
//                                 reject(message);
//                             },
//                             bytes);

//                         rgbdPostProcess!.getEffect().executeWhenCompiled(() => {
//                             // Uncompress the data to a RTT
//                             rgbdPostProcess!.onApply = (effect) => {
//                                 effect._bindTexture("textureSampler", tempTexture);
//                                 effect.setFloat2("scale", 1, 1);
//                             };

//                             engine.scenes[0].postProcessManager.directRender([rgbdPostProcess!], cubeRtt, true, face, i);

//                             // Cleanup
//                             engine.restoreDefaultFramebuffer();
//                             tempTexture.dispose();
//                             resolve(null);
//                         });
//                     }
//                     else {
//                         let size = bytes.byteLength;
//                         size = size / 4;
//                         size = Math.round(Math.sqrt(size));
//                         engine._uploadArrayBufferViewToTexture(texture, bytes, face, i);

//                         // Upload the face to the non lod texture support
//                         if (generateNonLODTextures) {
//                             let lodTexture = lodTextures![i];
//                             if (lodTexture) {
//                                 // engine._uploadImageToTexture(lodTexture._texture!, bytes, face, 0);
//                                 engine._uploadArrayBufferViewToTexture(texture, bytes, face, 0);
//                             }
//                         }
//                         resolve(null);
//                     }
//                 });
//                 promises.push(promise);
//             }
//         }

//         // Fill remaining mipmaps with black textures.
//         if (imageData.length < mipmapsCount) {
//             let data: ArrayBufferView;
//             const size = Math.pow(2, mipmapsCount - 1 - imageData.length);
//             const dataLength = size * size * 4;
//             switch (texture.type) {
//                 case Constants.TEXTURETYPE_UNSIGNED_INT: {
//                     data = new Uint8Array(dataLength);
//                     break;
//                 }
//                 case Constants.TEXTURETYPE_HALF_FLOAT: {
//                     data = new Uint16Array(dataLength);
//                     break;
//                 }
//                 case Constants.TEXTURETYPE_FLOAT: {
//                     data = new Float32Array(dataLength);
//                     break;
//                 }
//             }
//             for (let i = imageData.length; i < mipmapsCount; i++) {
//                 for (let face = 0; face < 6; face++) {
//                     engine._uploadArrayBufferViewToTexture(texture, data!, face, i);
//                 }
//             }
//         }

//         // Once all done, finishes the cleanup and return
//         return Promise.all(promises).then(() => {
//             // Release temp RTT.
//             if (cubeRtt) {
//                 engine._releaseFramebufferObjects(cubeRtt);
//                 engine._releaseTexture(texture);
//                 cubeRtt._swapAndDie(texture);
//             }
//             // Release temp Post Process.
//             if (rgbdPostProcess) {
//                 rgbdPostProcess.dispose();
//             }
//             // Flag internal texture as ready in case they are in use.
//             if (generateNonLODTextures) {
//                 if (texture._lodTextureHigh && texture._lodTextureHigh._texture) {
//                     texture._lodTextureHigh._texture.isReady = true;
//                 }
//                 if (texture._lodTextureMid && texture._lodTextureMid._texture) {
//                     texture._lodTextureMid._texture.isReady = true;
//                 }
//                 if (texture._lodTextureLow && texture._lodTextureLow._texture) {
//                     texture._lodTextureLow._texture.isReady = true;
//                 }
//             }
//         });
//     }
// }