/**
 *
 */

// ###################################################
// import { BABYLON_ANIMATION_TYPE } from '../util/res_mgr';
import { BABYLON } from './babylon';
import { ExtensionTools, Res, ResTab } from '../interface/index';
// ###################################################
declare let module;
let logger;
ExtensionTools.RegistStartUp(() => { logger = ExtensionTools.Logger(module.name, "BABYLON"); });

// ###################################################

// 实现babylon的脱机提供者， 从外部ResTab获取数据
export class OfflineProvider {
    public static onoffCollectInfo = false;
    public static piBABYLONResCollect = {};
    public static piBABYLONTextureRecord = new Map();
    public static piBABYLONGeometryRecord = new Map();
    public static piBABYLONFileRecord = new Map();

    // /**
    //  * 外部可拓展的gltf预处理接口
    //  * @param json GLTF 数据
    //  * @returns
    //  */
    public enableSceneOffline: boolean = true;
    public enableTexturesOffline: boolean = true;
    public resTab: ResTab = ExtensionTools.CreateResTab();

    constructor(resTab: ResTab) {
        this.resTab = resTab;
    }

    public release() {
        this.resTab.clear();
    }
}
