import { IVector3 } from "../interface/index";
import { BABYLON } from "../render3d/babylon";


export interface IRibbonPoint {
    size: number,
    normal: BABYLON.Vector3;
    tanget: BABYLON.Vector3;
    distance: number;
    position: BABYLON.Vector3;
    direction: BABYLON.Vector3;
}

export interface IPath {
    points: IRibbonPoint[];
}

export interface IRibbonRenderer {
    alphaIndex: number;
    image: string;
    addPoint(newPoint: IVector3): void;
    resetPoint(newPoint: IVector3[]): void;
    updateScale(uScale: number, vScale: number): void;
    destroy(): void;
}

