/**
 * 场景数据结构 - 高层
 */
import { ModelObj } from './model_obj';
import { IImageSolt, IMaterialSolt, ITransformCfg, IModelOpt, IModelChildOpt, IModelAttachOpt, SceneRenderFlags, Scene3DEventInfo } from './interface/modelobj';
import { SceneStruct } from './scene_struct';
import { LoaderTool } from './scene_tool';

export let ResPath = 'app/scene_res/res/';
export let SceneResPath = 'scenes/';
export let ModelResPath = 'models/';
export let NodeResPath = 'models/';
export let EffectResPath = 'effects/';

// 仅作导出至项目层的兼容用,需要保证注释后，底层没有引用错误,以确保底层没有循环引用
export {
    IImageSolt,
    IMaterialSolt,
    ITransformCfg,
    IModelOpt,
    IModelChildOpt,
    IModelAttachOpt,

    ModelObj,

    SceneStruct,

    SceneRenderFlags,
    Scene3DEventInfo
};

LoaderTool.getResPath = () => {
    return ResPath;
};
LoaderTool.getSceneResPath = () => {
    return SceneResPath;
};
LoaderTool.getModelResPath = () => {
    return ModelResPath;
};
LoaderTool.getNodeResPath = () => {
    return NodeResPath;
};
LoaderTool.getEffectResPath = () => {
    return EffectResPath;
};