import { IColliderItem, IPiCollider } from "./interface/extends";
import { BABYLON } from "./render3d/babylon";

export class PiCollider implements IPiCollider {
    
    /**
     * Constructs bounding info
     * @param minimum min vector of the bounding box/sphere
     * @param maximum max vector of the bounding box/sphere
     * @param worldMatrix defines the new world matrix
     */
    constructor(public minimum: BABYLON.DeepImmutable<BABYLON.Vector3>, public maximum: BABYLON.DeepImmutable<BABYLON.Vector3>, worldMatrix?: BABYLON.DeepImmutable<BABYLON.Matrix>) {
        
    }
    /**
     * Recreates the entire bounding info from scratch as if we call the constructor in place
     * @param min defines the new minimum vector (in local space)
     * @param max defines the new maximum vector (in local space)
     * @param worldMatrix defines the new world matrix
     */
    public reConstruct(min: BABYLON.DeepImmutable<BABYLON.Vector3>, max: BABYLON.DeepImmutable<BABYLON.Vector3>, worldMatrix?: BABYLON.DeepImmutable<BABYLON.Matrix>) {
        this.minimum.copyFrom(min);
        this.maximum.copyFrom(max);
    }

    /**
     * Updates the bounding sphere and box
     * @param world world matrix to be used to update
     */
    public update(world: BABYLON.DeepImmutable<BABYLON.Matrix>) {
        // this.boundingSphere._update(world);
        // this.boundingBox._update(world);
    }
    sphereTreshold: number = 0;
}
/**
 * * 不提供给本库外部使用
 * @hideconstructor
 */
export class ScenePickManager {
    public static Initial() {
    }
    constructor(public readonly scene: BABYLON.Scene) {

    }
    public addCollider(target: IColliderItem, minimum?: BABYLON.DeepImmutable<BABYLON.Vector3>, maximum?: BABYLON.DeepImmutable<BABYLON.Vector3>) {
    }
    public addEventListener(target: BABYLON.INode, etype: "pointerup" | "pointerdown", func: Function) {
    }
    public onPointerUp = (pointerX: number, pointerY: number) => {
    }
    public onPointerDown = (pointerX: number, pointerY: number) => {
    }
    public pick(pointerX: number, pointerY: number, items?: BABYLON.INode[]): BABYLON.INode | undefined {
        return undefined;
    }
}
